import pandas as pd

class basic:
	def __init__(self):

		self.var_color_name = {
			"빨": "red", "적": "red", "red":"red","r": "red", "빨강": "red",
			"주": "ora", "yr": "ora","yellowred":"ora","o":"ora","orange":"ora","ora":"ora","주황": "ora",
			"노": "yel", "y": "yel", "yellow": "yel", "yel": "yel", "노랑": "yel",
			"연": "gy", "gy": "gy", "greenyellow": "gy", "연두": "gy","green-yellow": "gy","yg": "gy",
			"초": "gre", "g": "gre", "green": "gre", "gre": "gre", "녹색": "gre","초록": "gre",
			"연초록":"gc", "green-cyan":"gc","cg":"gc","gc":"gc",
			"옥": "cya", "옥색": "cya", "c": "cya","cya": "cya","cyan": "cya",
			"청록": "bc","blue-cyan": "bc","청": "bc", "cb": "bc", "bg": "bc", "bluegreen": "bc","bc": "bc",
			"파": "blu", "b": "blu", "blue": "blu", "blu": "blu", "파랑": "blu",
			"남": "bm", "blue-magenta": "bm", "blue_magenta": "bm", "mb": "bm", "bm": "bm", "pb": "bm", "purpleblue": "bm", "violet": "bm", "vio": "bm", "남색": "bm",
			"보": "mag", "magenta": "mag", "m": "mag","보라": "mag","mag": "mag",
			"자홍": "rm", "red-magenta": "rm", "rm": "rm","red_magenta": "rm","mr": "rm","자주": "rm",
			"회": "gra", "회색": "gra", "gra": "gra", "gray": "gra",
			"흰": "whi", "하양": "whi", "white": "whi", "whi": "whi","흰색": "whi",
			"검": "bla", "검정": "bla", "black": "bla", "흑": "bla", "bla": "bla",
			}


		self.var_color_step = {
			"1": "1", "l4": "1", "++++": "1", "white": "1", "pastel": "1", "파스텔": "1", "p": "1","d4": "1",
			"2": "2", "l3": "2", "+++": "2", "pale": "2", "연한": "2", "d3": "2",
			"3": "3", "l2": "3", "++": "3", "light": "3", "밝은": "3", "d2": "3",
			"4": "4", "l1": "4", "+": "4", "soft": "4", "흐린": "4", "d1": "4",
			"5": "5", "l0": "5", "": "5", "vivid": "5", "선명한": "5", "basic": "5", "기본": "5", "d0": "5",
			"6": "6", "l-1": "6", "-": "6", "dull": "6", "탁한": "6", "d-1": "6",
			"7": "7", "l-2": "7", "--": "7", "deep": "7", "진한": "7", "d-2": "7",
			"8": "8", "l-3": "8", "---": "8", "dark": "8", "어두운": "8", "d-3": "8",
			"9": "9", "l-4": "9", "----": "9", "bla": "9", "검정": "9", "black": "9", "검은": "9", "d-4": "9",
			}


		self.var_color_mode ={1:"단색조합", "단색조합":1,"강력한 대기효과와 넓은공간감":1,
				              2:"등간격 3색 조화","등간격 3색 조화":2, "활동적인 인상과 이미지":2,
				              3:"보색", "보색":3, "강력한비교":3,
				              4:"인접색",  "인접색":4,"비슷한색 찾기":4,
				              5:"근접보색조합", "근접보색조합":5,"보색의 강한 인상이 부담스러울때 보색의 근처에있는 색":5,
				              6:"고명도배색", "고명도배색":6,
				              7:"고명도배색+약간더 부드러운 이미지", "고명도배색+약간더 부드러운 이미지":7,
				              8:"중명도배색",  "중명도배색":8,
							  9:"중명도배색+약간더 부드러운 이미지", "중명도배색+약간더 부드러운 이미지":9,
							  10:"저중명도배색",  "저중명도배색":10,
							  11:"저명도배색+약간더 어두운 이미지", "저명도배색+약간더 어두운 이미지":11,
							  12:"명도차가 큰 배색",  "명도차가 큰 배색":12,
							  13:"명도차가 큰 배색 + 근접보색", "명도차가 큰 배색 + 근접보색":13,
							  14:"고채도 배색",  "고채도 배색":14,
							  15:"채도차가 큰 배색", "채도차가 큰 배색":15,
							  16:"저채도 배색", "저채도 배색":16,"차분하고 무거운 이미지":16,
				              }
		self.var_color_mode= ["단색조합", "등간격 3색 조화","보색","인접색","근접보색조합",
					           "고명도배색", "고명도배색+약간더 부드러운 이미지",
					           "중명도배색", "중명도배색+약간더 부드러운 이미지", "저중명도배색", "저명도배색+약간더 어두운 이미지",
							   "명도차가 큰 배색", "명도차가 큰 배색 + 근접보색",
							   "고채도 배색", "채도차가 큰 배색", "저채도 배색",]

		self.var_excel_rgb = [[0,0,0], [255,255,255], [255,0,0], [0,255,0], [0,0,255], [255,255,0],
										[255,0,255], [0,255,255], [128,0,0], [0,128,0], [0,0,128], [128,128,0],
										[128,0,128], [0,128,128], [192,192,192], [128,128,128], [153,153,255],
										[153,51,102], [255,255,204], [204,255,255], [102,0,102], [255,128,128],
										[0,102,204], [204,204,255], [0,0,128], [255,0,255], [255,255,0],
										[0,255,255], [128,0,128], [128,0,0], [0,128,128], [0,0,255],
										[0,204,255], [204,255,255], [204,255,204], [255,255,153], [153,204,255],
										[255,153,204], [204,153,255], [255,204,153], [51,102,255], [51,204,204],
										[153,204,0], [255,204,0], [255,153,0], [255,102,0], [102,102,153],
										[150,150,150], [0,51,102], [51,153,102], [0,51,0], [51,51,0],
										[153,51,0], [153,51,102], [51,51,153], [51,51,51]]

		self.var_scolor_rgb = [[255, 0, 0],[255, 128, 0],[255, 255, 0],[128, 255, 0],
										[0, 255, 0],[0, 255, 128],[0, 255, 255],[0, 128, 255],
										[0, 0, 255],[128, 0, 255],[255, 0, 255],[255, 0, 128],]


		self.var_basic_hsl = [[0, 100, 50], [30, 100, 50], [60, 100, 50], [90, 100, 50], [120, 100, 50],
						                 [150, 100, 50], [180, 100, 50], [210, 100, 50], [240, 100, 50], [270, 100, 50],
						                 [300, 100, 50], [330, 100, 50]]

		self.var_h_basic= {"red": 0, "ora": 30, "yel": 60, "gy": 90, "gre": 120, "gc":150 , "cya": 180,
				       "bc": 210, "blu": 240, "bm": 270, "mag": 300, "rm": 330, "gra": 0, "whi": 0, "bla": 0, }

		self.var_s_step= {"1": [10], "2": [20], "3": [30], "4": [40],"5": [50], "6": [60], "7": [70], "8": [80], "9": [90], }

		self.var_l_step= {"1": [10], "2": [20], "3": [30], "4": [40],"5": [50], "6": [60], "7": [70], "8": [80], "9": [90], }

		self.var_sl_step= {"1": [100, 80], "2": [100, 77], "3": [100, 68], "4": [100, 59],
				  "5": [100, 50], "6": [90, 41], "7": [80, 32], "8": [70, 23], "9": [60, 14], }

		self.var_sl_step_small= {"1": [0, 12], "2": [0, 9], "3": [0, 6], "4": [0, 3],
				      "5": [0, 0], "6": [0, -3], "7": [0, -6], "8": [0, -9], "9": [0, -12], "0": [0, -14],}

		self.var_colorname_index= {"red":0, "ora":1, "yel":2, "gy":3, "gre":4, "gc":5, "cya":6, "bc":7, "blu":8, "bm":9, "mag":10, "rm":11, "gra":12, "whi":13, "bla":14}
		self.var_colorname_kor= ["빨강", "주황", "노랑", "연두", "초록", "연초록", "옥색", "청록", "파랑", "남색", "보라", "자홍", "회색", "흰색", "검정"]
		self.var_colorname_eng= ["red", "ora", "yel", "gy", "gre", "gc", "cya", "bc", "blu", "bm", "mag", "rm", "gra", "whi", "bla"]
		self.var_colorname_eng_s= ["r", "o", "y", "gy", "g", "gc", "c", "bc", "b", "bm", "m", "rm", "g", "w", "bl"]
		self.var_color_style_kor= ["파스텔", "연한", "밝은", "흐린", "선명한", "기본", "탁한", "진한", "어두운", "회색", "검은", "검정"]
		self.var_color_style_eng= ["white", "pale", "light", "soft", "vivid", "dull", "deep", "dark", "black", "회색", "검은", "검정"]

		self.var_trcode = {"opt10001":"주식기본정보요청", "opt10002": "주식거래원요청",
				"opt10003": "체결정보요청", "opt10004": "주식호가요청",		"opt10005": "주식일주월시분요청", "OPT10006": "주식시분요청",
				"opt10007": "시세표성정보요청", "opt10008": "주식외국인요청",		"OPT10009": "주식기관요청", "OPT10010": "업종프로그램요청",
				"opt10011": "신주인수권전체시세요청", "opt10012": "주문체결요청",		"opt10013": "신용매매동향요청", "opt10014": "공매도추이요청",
				"opt10015": "일별거래상세요청", "OPT10016": "신고저가요청",		"opt10017": "상하한가요청", "OPT10018": "고저가근접요청",
				"opt10019": "가격급등락요청",		"OPT10020": "호가잔량상위요청", "OPT10021": "호가잔량급증요청",
				"OPT10022": "잔량율급증요청", "OPT10023": "거래량급증요청",
				"OPT10024": "거래량갱신요청", "OPT10025": "매물대집중요청", "opt10026": "고저PER요청",
				"opt10027": "전일대비등락률상위요청", "opt10028": "시가대비등락률요청", "opt10029": "예상체결등락률상위요청", "OPT10032": "거래대금상위요청",
				"opt10033": "신용비율상위요청", "OPT10034": "외인기간별매매상위요청",		"OPT10035": "외인연속순매매상위요청", "opt10036": "매매상위요청",
				"opt10037": "외국계창구매매상위요청", "opt10038": "종목별증권사순위요청",		"OPT10039": "증권사별매매상위요청", "opt10040": "당일주요거래원요청",
				"opt10042": "순매수거래원순위요청", "opt10043": "거래원매물대분석요청",		"OPT10044": "일별기관매매종목요청", "opt10045": "종목별기관매매추이요청",
				"opt10046": "체결강도추이시간별요청", "opt10047": "체결강도추이일별요청", "OPT10048": "ELW일별민감도지표요청",
				"OPT10050": "ELW민감도지표요청", "OPT10051": "업종별투자자순매수요청",		"opt10052": "거래원순간거래량요청", "opt10053": "당일상위이탈원요청",
				"opt10054": "변동성완화장치발동종목요청", "opt10055": "당일전일체결대량요청",		"OPT10058": "투자자별일별매매종목요청", "opt10059": "종목별투자자기관별요청",
				"opt10060": "종목별투자자기관별차트요청", "opt10061": "종목별투자자기관별합계요청",		"opt10062": "동일순매매순위요청",
				"opt10063": "장중투자자별매매요청", "opt10064": "장중투자자별매매차트요청", "OPT10065": "장중투자자별매매상위요청",
				"opt10066": "장중투자자별매매차트요청", "OPT10067": "대차거래내역요청",
				"OPT10068": "대차거래추이요청", "OPT10069": "대차거래상위10종목요청", "opt10070": "당일주요거래원요청",
				"OPT10071": "시간대별전일비거래비중요청", "OPT10072": "일자별종목별실현손익요청",
				"opt10073": "일자별종목별실현손익요청", "opt10074": "일자별실현손익요청", "opt10075": "실시간미체결요청", "opt10076": "실시간체결요청",
				"opt10077": "당일실현손익상세요청", "OPT10078": "증권사별종목매매동향요청", "opt10079": "주식틱차트조회요청",
				"opt10080": "주식분봉차트조회요청", "opt10081": "주식일봉차트조회요청",		"opt10082": "주식주봉차트조회요청", "opt10083": "주식주봉차트조회요청",
				"opt10084": "당일전일체결요청", "opt10085": "계좌수익률요청", "opt10086": "일별주가요청",		"opt10087": "시간외단일가요청", "opt10094": "주식년봉차트조회요청",
				"opt20001": "업종현재가요청", "OPT20002": "업종별주가요청", "opt20003": "전업종지수요청",
				"opt20004": "업종틱차트조회요청", "opt20005": "업종분봉조회요청", "opt20006": "업종일봉조회요청",
				"opt20007": "업종주봉조회요청", "opt20008": "업종월봉조회요청",		"opt20009": "업종현재가일별요청", "opt20019": "업종년봉조회요청",
				"opt20068": "대차거래추이요청(종목별)", "OPT30001": "ELW가격급등락요청",		"OPT30002": "거래원별ELW순매매상위요청", "OPT30004": "ELW괴리율요청",
				"opt30005": "ELW조건검색요청", "OPT30008": "ELW민감도지표요청",
				"OPT30009": "ELW등락율순위요청", "OPT30010": "ELW잔량순위요청", "OPT30011": "ELW근접율요청",
				"opt30012": "ELW종목상세정보요청", "OPT40001": "ETF수익율요청", "opt40002": "ETF종목정보요청",
				"OPT40003": "ETF일별추이요청", "opt40004": "ETF전체시세요청", "OPT40005": "ETF일별추이요청",
				"opt40007": "ETF시간대별체결요청", "opt40008": "ETF시간대별체결요청", "OPT40009": "ETF시간대별체결요청",
				"opt40010": "ETF시간대별추이요청", "opt50004": "콜옵션행사가요청", "opt50007": "선물시세추이요청",
				"opt50008": "프로그램매매추이차트요청", "OPT50009": "선옵시간별잔량요청",		"OPT50010": "선옵호가잔량추이요청", "OPT50011": "선옵호가잔량추이요청",
				"OPT50012": "선옵타임스프레드차트요청", "OPT50013": "선물가격대별비중차트요청",		"OPT50014": "선물가격대별비중차트요청", "opt50015": "선물미결제약정일차트요청",
				"OPT50016": "베이시스추이차트요청", "OPT50017": "베이시스추이차트요청",		"OPT50018": "풋콜옵션비율차트요청", "opt50020": "복수종목결제월별시세요청",
				"OPT50021": "콜종목결제월별시세요청", "OPT50022": "풋종목결제월별시세요청",		"opt50023": "민감도지표추이요청", "OPT50024": "일별변동성분석그래프요청",
				"OPT50026": "선옵주문체결요청", "opt50028": "선물틱차트요청",		"OPT50029": "선물옵션분차트요청", "OPT50030": "선물옵션일차트요청",
				"OPT50035": "지수변동성차트요청", "OPT50036": "주요지수변동성차트요청", "opt50037": "코스피200지수요청",
				"opt50038": "투자자별만기손익차트요청", "OPT50043": "주식선물거래량상위종목요청", "opt50062": "선물미결제약정분차트요청",
				"opt50063": "옵션미결제약정일차트요청", "opt50064": "옵션미결제약정분차트요청",		"opt50065": "풋옵션행사가요청", "opt50066": "옵션틱차트요청",
				"opt50067": "옵션분차트요청", "opt50068": "옵션일차트요청",		"OPT90001": "테마그룹별요청", "opt90002": "테마구성종목요청",
				"opt90003": "프로그램순매수상위50요청", "OPT90004": "종목별프로그램매매현황요청", "OPT90005": "프로그램매매추이요청",
				"OPT90006": "프로그램매매차익잔고추이요청", "OPT90007": "프로그램매매누적추이요청",
				"opt90008": "종목시간별프로그램매매추이요청", "opt90009": "외국인기관매매상위요청", "OPT90010": "차익잔고현황요청",
				"opt90011": "차익잔고현황요청", "OPT90012": "대차거래내역요청",
				"opt90013": "종목일별프로그램매매추이요청", "opw00001": "예수금상세현황요청", "OPW00002": "일별추정예탁자산현황요청",
				"OPW00003": "추정자산조회요청", "OPW00004": "계좌평가현황요청",		"opw00005": "체결잔고요청", "OPW00006": "관리자별주문체결내역요청",
				"OPW00007": "계좌별주문체결내역상세요청", "opw00008": "계좌별익일결제예정내역요청",		"opw00009": "계좌별주문체결현황요청", "opw00010": "주문인출가능금액요청",
				"opw00011": "증거금율별주문가능수량조회요청", "OPW00012": "신용보증금율별주문가능수량조회요청",
				"opw00013": "증거금세부내역조회요청", "OPW00014": "비밀번호일치여부요청",		"OPW00015": "위탁종합거래내역요청", "OPW00016": "일별계좌수익률상세현황요청",
				"OPW00017": "계좌별당일현황요청", "opw00018": "계좌평가잔고내역요청",		"OPW20001": "선물옵션청산주문위탁증거금가계산요청", "OPW20002": "선옵당일매매변동현황요청",
				"opw20003": "선옵기간손익조회요청", "OPW20004": "선옵주문체결내역상세요청",		"OPW20005": "선옵주문체결내역상세평균가요청", "opw20006": "선옵잔고상세현황요청",
				"OPW20007": "선옵잔고현황정산가기준요청", "OPW20008": "계좌별결제예상내역조회요청",		"opw20009": "선옵계좌별주문가능수량요청", "OPW20010": "선옵예탁금및증거금조회요청",
				"OPW20011": "선옵계좌예비증거금상세요청", "opw20012": "선옵증거금상세내역요청",		"OPW20013": "계좌미결제청산가능수량조회요청", "OPW20014": "선옵실시간증거금산출요청",
				"opw20015": "옵션매도주문증거금현황요청", "opw20016": "신용융자 가능종목요청",}

		self.var_trcode_list = [["opt10001", "주식기본정보요청"], ["opt10002", "주식거래원요청"],
				["opt10003", "체결정보요청"], ["opt10004", "주식호가요청"],["opt10005", "주식일주월시분요청"], ["OPT10006", "주식시분요청"],
				["opt10007", "시세표성정보요청"], ["opt10008", "주식외국인요청"],["OPT10009", "주식기관요청"], ["OPT10010", "업종프로그램요청"],
				["opt10011", "신주인수권전체시세요청"], ["opt10012", "주문체결요청"],["opt10013", "신용매매동향요청"], ["opt10014", "공매도추이요청"],
				["opt10015", "일별거래상세요청"], ["OPT10016", "신고저가요청"],["opt10017", "상하한가요청"], ["OPT10018", "고저가근접요청"],
				["opt10019", "가격급등락요청"],["OPT10020", "호가잔량상위요청"], ["OPT10021", "호가잔량급증요청"],
				["OPT10022", "잔량율급증요청"], ["OPT10023", "거래량급증요청"],
				["OPT10024", "거래량갱신요청"], ["OPT10025", "매물대집중요청"], ["opt10026", "고저PER요청"],
				["opt10027", "전일대비등락률상위요청"], ["opt10028", "시가대비등락률요청"], ["opt10029", "예상체결등락률상위요청"], ["OPT10032", "거래대금상위요청"],
				["opt10033", "신용비율상위요청"], ["OPT10034", "외인기간별매매상위요청"],["OPT10035", "외인연속순매매상위요청"], ["opt10036", "매매상위요청"],
				["opt10037", "외국계창구매매상위요청"], ["opt10038", "종목별증권사순위요청"],["OPT10039", "증권사별매매상위요청"], ["opt10040", "당일주요거래원요청"],
				["opt10042", "순매수거래원순위요청"], ["opt10043", "거래원매물대분석요청"],["OPT10044", "일별기관매매종목요청"], ["opt10045", "종목별기관매매추이요청"],
				["opt10046", "체결강도추이시간별요청"], ["opt10047", "체결강도추이일별요청"], ["OPT10048", "ELW일별민감도지표요청"],
				["OPT10050", "ELW민감도지표요청"], ["OPT10051", "업종별투자자순매수요청"],["opt10052", "거래원순간거래량요청"], ["opt10053", "당일상위이탈원요청"],
				["opt10054", "변동성완화장치발동종목요청"], ["opt10055", "당일전일체결대량요청"],["OPT10058", "투자자별일별매매종목요청"], ["opt10059", "종목별투자자기관별요청"],
				["opt10060", "종목별투자자기관별차트요청"], ["opt10061", "종목별투자자기관별합계요청"],["opt10062", "동일순매매순위요청"],
				["opt10063", "장중투자자별매매요청"], ["opt10064", "장중투자자별매매차트요청"], ["OPT10065", "장중투자자별매매상위요청"],
				["opt10066", "장중투자자별매매차트요청"], ["OPT10067", "대차거래내역요청"],
				["OPT10068", "대차거래추이요청"], ["OPT10069", "대차거래상위10종목요청"], ["opt10070", "당일주요거래원요청"],
				["OPT10071", "시간대별전일비거래비중요청"], ["OPT10072", "일자별종목별실현손익요청"],
				["opt10073", "일자별종목별실현손익요청"], ["opt10074", "일자별실현손익요청"], ["opt10075", "실시간미체결요청"], ["opt10076", "실시간체결요청"],
				["opt10077", "당일실현손익상세요청"], ["OPT10078", "증권사별종목매매동향요청"], ["opt10079", "주식틱차트조회요청"],
				["opt10080", "주식분봉차트조회요청"], ["opt10081", "주식일봉차트조회요청"],["opt10082", "주식주봉차트조회요청"], ["opt10083", "주식주봉차트조회요청"],
				["opt10084", "당일전일체결요청"], ["opt10085", "계좌수익률요청"], ["opt10086", "일별주가요청"],["opt10087", "시간외단일가요청"], ["opt10094", "주식년봉차트조회요청"],
				["opt20001", "업종현재가요청"], ["OPT20002", "업종별주가요청"], ["opt20003", "전업종지수요청"],
				["opt20004", "업종틱차트조회요청"], ["opt20005", "업종분봉조회요청"], ["opt20006", "업종일봉조회요청"],
				["opt20007", "업종주봉조회요청"], ["opt20008", "업종월봉조회요청"],["opt20009", "업종현재가일별요청"], ["opt20019", "업종년봉조회요청"],
				["opt20068", "대차거래추이요청(종목별)"], ["OPT30001", "ELW가격급등락요청"],["OPT30002", "거래원별ELW순매매상위요청"], ["OPT30004", "ELW괴리율요청"],
				["opt30005", "ELW조건검색요청"], ["OPT30008", "ELW민감도지표요청"],
				["OPT30009", "ELW등락율순위요청"], ["OPT30010", "ELW잔량순위요청"], ["OPT30011", "ELW근접율요청"],
				["opt30012", "ELW종목상세정보요청"], ["OPT40001", "ETF수익율요청"], ["opt40002", "ETF종목정보요청"],
				["OPT40003", "ETF일별추이요청"], ["opt40004", "ETF전체시세요청"], ["OPT40005", "ETF일별추이요청"],
				["opt40007", "ETF시간대별체결요청"], ["opt40008", "ETF시간대별체결요청"], ["OPT40009", "ETF시간대별체결요청"],
				["opt40010", "ETF시간대별추이요청"], ["opt50004", "콜옵션행사가요청"], ["opt50007", "선물시세추이요청"],
				["opt50008", "프로그램매매추이차트요청"], ["OPT50009", "선옵시간별잔량요청"],["OPT50010", "선옵호가잔량추이요청"], ["OPT50011", "선옵호가잔량추이요청"],
				["OPT50012", "선옵타임스프레드차트요청"], ["OPT50013", "선물가격대별비중차트요청"],["OPT50014", "선물가격대별비중차트요청"], ["opt50015", "선물미결제약정일차트요청"],
				["OPT50016", "베이시스추이차트요청"], ["OPT50017", "베이시스추이차트요청"],["OPT50018", "풋콜옵션비율차트요청"], ["opt50020", "복수종목결제월별시세요청"],
				["OPT50021", "콜종목결제월별시세요청"], ["OPT50022", "풋종목결제월별시세요청"],["opt50023", "민감도지표추이요청"], ["OPT50024", "일별변동성분석그래프요청"],
				["OPT50026", "선옵주문체결요청"], ["opt50028", "선물틱차트요청"],["OPT50029", "선물옵션분차트요청"], ["OPT50030", "선물옵션일차트요청"],
				["OPT50035", "지수변동성차트요청"], ["OPT50036", "주요지수변동성차트요청"], ["opt50037", "코스피200지수요청"],
				["opt50038", "투자자별만기손익차트요청"], ["OPT50043", "주식선물거래량상위종목요청"], ["opt50062", "선물미결제약정분차트요청"],
				["opt50063", "옵션미결제약정일차트요청"], ["opt50064", "옵션미결제약정분차트요청"],["opt50065", "풋옵션행사가요청"], ["opt50066", "옵션틱차트요청"],
				["opt50067", "옵션분차트요청"], ["opt50068", "옵션일차트요청"],["OPT90001", "테마그룹별요청"], ["opt90002", "테마구성종목요청"],
				["opt90003", "프로그램순매수상위50요청"], ["OPT90004", "종목별프로그램매매현황요청"], ["OPT90005", "프로그램매매추이요청"],
				["OPT90006", "프로그램매매차익잔고추이요청"], ["OPT90007", "프로그램매매누적추이요청"],
				["opt90008", "종목시간별프로그램매매추이요청"], ["opt90009", "외국인기관매매상위요청"], ["OPT90010", "차익잔고현황요청"],
				["opt90011", "차익잔고현황요청"], ["OPT90012", "대차거래내역요청"],
				["opt90013", "종목일별프로그램매매추이요청"], ["opw00001", "예수금상세현황요청"], ["OPW00002", "일별추정예탁자산현황요청"],
				["OPW00003", "추정자산조회요청"], ["OPW00004", "계좌평가현황요청"],["opw00005", "체결잔고요청"], ["OPW00006", "관리자별주문체결내역요청"],
				["OPW00007", "계좌별주문체결내역상세요청"], ["opw00008", "계좌별익일결제예정내역요청"],["opw00009", "계좌별주문체결현황요청"], ["opw00010", "주문인출가능금액요청"],
				["opw00011", "증거금율별주문가능수량조회요청"], ["OPW00012", "신용보증금율별주문가능수량조회요청"],
				["opw00013", "증거금세부내역조회요청"], ["OPW00014", "비밀번호일치여부요청"],["OPW00015", "위탁종합거래내역요청"], ["OPW00016", "일별계좌수익률상세현황요청"],
				["OPW00017", "계좌별당일현황요청"], ["opw00018", "계좌평가잔고내역요청"],["OPW20001", "선물옵션청산주문위탁증거금가계산요청"], ["OPW20002", "선옵당일매매변동현황요청"],
				["opw20003", "선옵기간손익조회요청"], ["OPW20004", "선옵주문체결내역상세요청"],["OPW20005", "선옵주문체결내역상세평균가요청"], ["opw20006", "선옵잔고상세현황요청"],
				["OPW20007", "선옵잔고현황정산가기준요청"], ["OPW20008", "계좌별결제예상내역조회요청"],["opw20009", "선옵계좌별주문가능수량요청"], ["OPW20010", "선옵예탁금및증거금조회요청"],
				["OPW20011", "선옵계좌예비증거금상세요청"], ["opw20012", "선옵증거금상세내역요청"],["OPW20013", "계좌미결제청산가능수량조회요청"], ["OPW20014", "선옵실시간증거금산출요청"],
				["opw20015", "옵션매도주문증거금현황요청"], ["opw20016", "신용융자 가능종목요청"]]


		self.var_trcode_outpput = {"opt10001": ["종목코드", "종목명", "결산월", "액면가", "자본금", "상장주식", "신용비율", "연중최고", "연중최저", "시가총액", "시가총액비중", "외인소진률", "대용가",
				              "PER", "EPS", "ROE", "PBR", "EV", "BPS", "매출액", "영업이익", "당기순이익", "250최고", "250최저", "시가", "고가", "저가",
				              "상한가", "하한가", "기준가", "예상체결가", "예상체결수량", "250최고가일", "250최고가대비율", "250최저가일", "250최저가대비율", "현재가", "대비기호",
				              "전일대비", "등락율", "거래량", "거래대비", "액면가단위", "유통주식", "유통비율"],
				 "opt10002": ["종목코드", "종목명", "현재가", "등락부호", "기준가", "전일대비", "등락율", "매도거래원명1", "매도거래원1", "매도거래량1", "매수거래원명1",
				              "매수거래원1", "매수거래량1", "매도거래원명2", "매도거래원2", "매도거래량2", "매수거래원명2", "매수거래원2", "매수거래량2", "매도거래원명3", "매도거래원3",
				              "매도거래량3", "매수거래원명3", "매수거래원3", "매수거래량3", "매도거래원명4", "매도거래원4", "매도거래량4", "매수거래원명4", "매수거래원4", "매수거래량4",
				              "매도거래원명5", "매도거래원5", "매도거래량5", "매수거래원명5", "매수거래원5", "매수거래량5"],
				 "opt10003": ["시간", "현재가", "전일대비", "대비율", "우선매도호가단위", "우선매수호가단위", "체결거래량", "sign", "누적거래량", "누적거래대금", "체결강도"],
				 "opt10004": ["호가잔량기준시간", "매도10차선잔량대비", "매도10차선잔량", "매도10차선호가", "매도9차선잔량대비", "매도9차선잔량", "매도9차선호가", "매도8차선잔량대비",
				              "매도8차선잔량", "매도8차선호가", "매도7차선잔량대비", "매도7차선잔량", "매도7차선호가", "매도6차선잔량대비", "매도6우선잔량", "매도6차선호가",
				              "매도5차선잔량대비", "매도5차선잔량", "매도5차선호가", "매도4차선잔량대비", "매도4차선잔량", "매도4차선호가", "매도3차선잔량대비", "매도3차선잔량",
				              "매도3차선호가", "매도2차선잔량대비", "매도2차선잔량", "매도2차선호가", "매도1차선잔량대비", "매도최우선잔량", "매도최우선호가", "매수최우선호가", "매수최우선잔량",
				              "매수1차선잔량대비", "매수2차선호가", "매수2차선잔량", "매수2차선잔량대비", "매수3차선호가", "매수3차선잔량", "매수3차선잔량대비", "매수4차선호가",
				              "매수4차선잔량", "매수4차선잔량대비", "매수5차선호가", "매수5차선잔량", "매수5차선잔량대비", "매수6우선호가", "매수6우선잔량", "매수6차선잔량대비",
				              "매수7차선호가", "매수7차선잔량", "매수7차선잔량대비", "매수8차선호가", "매수8차선잔량", "매수8차선잔량대비", "매수9차선호가", "매수9차선잔량",
				              "매수9차선잔량대비", "매수10차선호가", "매수10차선잔량", "매수10차선잔량대비", "총매도잔량직전대비", "총매도잔량", "총매수잔량", "총매수잔량직전대비",
				              "시간외매도잔량대비", "시간외매도잔량", "시간외매수잔량", "시간외매수잔량대비"],
				 "opt10005": ["날짜", "시가", "고가", "저가", "종가", "대비", "등락률", "거래량", "거래대금", "체결강도", "외인보유", "외인비중", "외인순매수", "기관순매수",
				              "개인순매수", "외국계", "신용잔고율", "프로그램"],
				 "OPT10006": ["날짜", "시가", "고가", "저가", "종가", "대비", "등락률", "거래량", "거래대금", "체결강도"],
				 "opt10007": ["종목명", "종목코드", "날짜", "시간", "전일종가", "전일거래량", "상한가", "하한가", "전일거래대금", "상장주식수", "현재가", "부호", "등락률",
				              "전일비", "시가", "고가", "저가", "체결량", "거래량", "거래대금", "예상체결가", "예상체결량", "예상매도우선호가", "예상매수우선호가", "거래시작일",
				              "행사가격", "최고가", "최저가", "최고가일", "최저가일", "매도1호가", "매도2호가", "매도3호가", "매도4호가", "매도5호가", "매도6호가", "매도7호가",
				              "매도8호가", "매도9호가", "매도10호가", "매수1호가", "매수2호가", "매수3호가", "매수4호가", "매수5호가", "매수6호가", "매수7호가", "매수8호가",
				              "매수9호가", "매수10호가", "매도1호가잔량", "매도2호가잔량", "매도3호가잔량", "매도4호가잔량", "매도5호가잔량", "매도6호가잔량", "매도7호가잔량",
				              "매도8호가잔량", "매도9호가잔량", "매도10호가잔량", "매수1호가잔량", "매수2호가잔량", "매수3호가잔량", "매수4호가잔량", "매수5호가잔량", "매수6호가잔량",
				              "매수7호가잔량", "매수8호가잔량", "매수9호가잔량", "매수10호가잔량", "매도1호가직전대비", "매도2호가직전대비", "매도3호가직전대비", "매도4호가직전대비",
				              "매도5호가직전대비", "매도6호가직전대비", "매도7호가직전대비", "매도8호가직전대비", "매도9호가직전대비", "매도10호가직전대비", "매수1호가직전대비",
				              "매수2호가직전대비", "매수3호가직전대비", "매수4호가직전대비", "매수5호가직전대비", "매수6호가직전대비", "매수7호가직전대비", "매수8호가직전대비",
				              "매수9호가직전대비", "매수10호가직전대비", "매도1호가건수", "매도2호가건수", "매도3호가건수", "매도4호가건수", "매도5호가건수", "매수1호가건수",
				              "매수2호가건수", "매수3호가건수", "매수4호가건수", "매수5호가건수", "LP매도1호가잔량", "LP매도2호가잔량", "LP매도3호가잔량", "LP매도4호가잔량",
				              "LP매도5호가잔량", "LP매도6호가잔량", "LP매도7호가잔량", "LP매도8호가잔량", "LP매도9호가잔량", "LP매도10호가잔량", "LP매수1호가잔량",
				              "LP매수2호가잔량", "LP매수3호가잔량", "LP매수4호가잔량", "LP매수5호가잔량", "LP매수6호가잔량", "LP매수7호가잔량", "LP매수8호가잔량",
				              "LP매수9호가잔량", "LP매수10호가잔량", "총매수잔량", "총매도잔량", "총매수건수", "총매도건수"],
				 "opt10008": ["일자", "종가", "전일대비", "거래량", "변동수량", "보유주식수", "비중", "취득가능주식수", "외국인한도", "외국인한도증감", "한도소진률"],
				 "OPT10009": ["날짜", "종가", "대비", "기관기간누적", "기관일변순매매", "외국인일변순매매", "외국인지분율"],
				 "OPT10010": ["차익위탁매도수량", "차익위탁매도금액", "차익위탁매수수량", "차익위탁매수금액", "차익위탁순매수수량", "차익위탁순매수금액", "비차익위탁매도수량", "비차익위탁매도금액",
				              "비차익위탁매수수량", "비차익위탁매수금액", "비차익위탁순매수수량", "비차익위탁순매수금액", "전체차익위탁매도수량", "전체차익위탁매도금액", "전체차익위탁매수수량",
				              "전체차익위탁매수금액", "전체차익위탁순매수수량", "전체차익위탁순매수금액"],
				 "opt10011": ["종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "등락율", "최우선매도호가", "최우선매수호가", "누적거래량", "시가", "고가", "저가"],
				 "opt10012": ["주문수량", "주문가격", "미체결수량", "체결누계금액", "원주문번호", "주문구분", "매매구분", "매도수구분", "주문/체결시간", "체결가", "체결량", "주문상태",
				              "단위체결가", "대출일", "신용구분", "만기일", "보유수량", "매입단가", "총매입가", "주문가능수량", "당일매도수량", "당일매도금액", "당일매수수량",
				              "당일매수금액", "당일매매수수료", "당일매매세금", "당일hts매도수수료", "당일hts매수수수료", "당일매도손익", "당일순매수량", "매도/매수구분", "당일총매도손일",
				              "예수금", "사용가능현금", "사용가능대용", "전일재사용", "당일재사용", "담보현금", "신용금액", "신용이자", "담보대출수량", "현물주문체결이상유무",
				              "현물잔고이상유무", "현물예수금이상유무", "선물주문체결이상유무", "선물잔고이상유무", "D+1추정예수금", "D+2추정예수금", "D+1매수/매도정산금",
				              "D+2매수/매도정산금", "D+1연체변제소요금", "D+2연체변제소요금", "D+1추정인출가능금", "D+2추정인출가능금", "현금증거금", "대용잔고", "대용증거금",
				              "수표금액", "현금미수금", "신용설정보증금", "인출가능금액"],
				 "opt10013": ["일자", "현재가", "전일대비기호", "전일대비", "거래량", "신규", "상환", "잔고", "금액", "대비", "공여율", "잔고율"],
				 "opt10014": ["일자", "종가", "전일대비기호", "전일대비", "등락율", "거래량", "공매도량", "매매비중", "공매도거래대금", "공매도평균가"],
				 "opt10015": ["일자", "종가", "전일대비기호", "전일대비", "등락율", "거래량", "거래대금", "장전거래량", "장전거래비중", "장중거래량", "장중거래비중", "장후거래량",
				              "장후거래비중", "합계3", "기간중거래량", "체결강도", "외인보유", "외인비중", "외인순매수", "기관순매수", "개인순매수", "외국계", "신용잔고율", "프로그램",
				              "장전거래대금", "장전거래대금비중", "장중거래대금", "장중거래대금비중", "장후거래대금", "장후거래대금비중"],
				 "OPT10016": ["종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "등락률", "거래량", "전일거래량대비율", "매도호가", "매수호가", "고가", "저가"],
				 "opt10017": ["종목코드", "종목정보", "종목명", "현재가", "전일대비기호", "전일대비", "등락률", "거래량", "전일거래량", "매도잔량", "매도호가", "매수호가", "매수잔량",
				              "횟수"],
				 "OPT10018": ["종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "등락률", "거래량", "매도호가", "매수호가", "당일고가", "당일저가"],
				 "opt10019": ["종목코드", "종목분류", "종목명", "전일대비기호", "전일대비", "등락률", "기준가", "현재가", "기준대비", "거래량", "급등률"],
				 "OPT10020": ["종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "거래량", "총매도잔량", "총매수잔량", "순매수잔량", "매수비율"],
				 "OPT10021": ["종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "기준률", "현재", "급증수량", "급증률", "총매수량"],
				 "OPT10022": ["종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "기준률", "현재비율", "급증률", "총매도잔량", "총매수잔량"],
				 "OPT10023": ["종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "등락률", "이전거래량", "현재거래량", "급증량", "급증률"],
				 "OPT10024": ["종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "등락률", "이전거래량", "현재거래량", "매도호가", "매수호가"],
				 "OPT10025": ["종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "등락률", "현재거래량", "가격대시작", "가격대끝", "매물량", "매물비"],
				 "opt10026": ["종목코드", "종목명", "PER", "현재가", "전일대비기호", "전일대비", "등락률", "현재거래량", "매도호가"],
				 "opt10027": ["종목분류", "종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "등락률", "매도잔량", "매수잔량", "현재거래량", "체결강도", "횟수"],
				 "opt10028": ["종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "등락률", "시가", "고가", "저가", "시가대비", "현재거래량", "체결강도"],
				 "opt10029": ["종목코드", "종목명", "예상체결가", "기준가", "전일대비기호", "전일대비", "등락률", "예상체결량", "매도잔량", "매도호가", "매수호가", "매수잔량"],
				 "OPT10032": ["종목코드", "현재순위", "전일순위", "종목명", "현재가", "전일대비기호", "전일대비", "등락률", "매도호가", "매수호가", "현재거래량", "전일거래량",
				              "거래대금"],
				 "opt10033": ["종목정보", "종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "등락률", "신용비율", "매도잔량", "매수잔량", "현재거래량"],
				 "OPT10034": ["순위", "종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "매도호가", "매수호가", "거래량", "순매수량", "취득가능주식수"],
				 "OPT10035": ["종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "D-1", "D-2", "D-3", "합계", "한도소진율", "전일대비1", "전일대비2",
				              "전일대비3"],
				 "opt10036": ["순위", "종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "거래량", "보유주식수", "취득가능주식수", "기준한도소진율", "한도소진율", "소진율증가"],
				 "opt10037": ["순위", "종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "등락율", "매도거래량", "매수거래량", "순매수거래량", "순매수대금", "거래량",
				              "거래대금"], "opt10038": ["순위1", "순위2", "순위3", "기간중거래량"],
				 "OPT10039": ["순위", "종목코드", "종목명", "기간중주가등락", "등락율", "기간중거래량", "순매수", "매수거래량", "매도거래량"],
				 "opt10040": ["매도거래원별증감1", "매도거래원수량1", "매도거래원1", "매도거래원코드1", "매수거래원1", "매수거래원코드1", "매수거래원수량1", "매수거래원별증감1",
				              "매도거래원별증감2", "매도거래원수량2", "매도거래원2", "매도거래원코드2", "매수거래원2", "매수거래원코드2", "매수거래원수량2", "매수거래원별증감2",
				              "매도거래원별증감3", "매도거래원수량3", "매도거래원3", "매도거래원코드3", "매수거래원3", "매수거래원코드3", "매수거래원수량3", "매수거래원별증감3",
				              "매도거래원별증감4", "매도거래원수량4", "매도거래원4", "매도거래원코드4", "매수거래원4", "매수거래원코드4", "매수거래원수량4", "매수거래원별증감4",
				              "매도거래원별증감5", "매도거래원수량5", "매도거래원5", "매도거래원코드5", "매수거래원5", "매수거래원코드5", "매수거래원수량5", "매수거래원별증감5",
				              "외국계매도추정합변동", "외국계매도추정합", "외국계매수추정합", "외국계매수추정합변동"], "opt10042": ["순위", "회원사코드", "회원사명"],
				 "opt10043": ["일자", "종가", "대비기호", "전일대비", "매도량", "매수량", "순매수수량", "거래량합", "거래비중"],
				 "OPT10044": ["종목코드", "종목명", "순매수수량", "순매수금액", "추정평균가", "현재가", "평균가대비", "대비율"], "opt10045": ["기관추정평균가", "외인추정평균가"],
				 "opt10046": ["체결시간", "현재가", "전일대비", "전일대비기호", "등락율", "거래량", "누적거래대금", "누적거래량", "체결강도", "체결강도5분", "체결강도20분",
				              "체결강도60분"],
				 "opt10047": ["일자", "현재가", "전일대비", "전일대비기호", "등락율", "거래량", "누적거래대금", "누적거래량", "체결강도", "체결강도5분", "체결강도20분",
				              "체결강도60분"], "OPT10048": ["일자", "IV", "델타", "감마", "쎄타", "베가", "로", "LP"],
				 "OPT10050": ["체결시간", "현재가", "ELW이론가", "IV", "델타", "감마", "쎄타", "베가", "로", "LP"],
				 "OPT10051": ["업종코드", "업종명", "현재가", "대비부호", "전일대비", "등락율", "거래량", "증권순매수", "보험순매수", "투신순매수", "은행순매수", "종신금순매수",
				              "기금순매수", "기타법인순매수", "개인순매수", "외국인순매수", "내국인대우외국인순매수", "국가순매수", "사모펀드순매수", "기관계순매수"],
				 "opt10052": ["시간", "종목코드", "종목명", "거래원명", "구분", "순간거래량", "누적순매수", "현재가", "전일대비기호", "전일대비", "전일대비"],
				 "opt10053": ["매도이탈시간", "매도수량", "매도상위이탈원", "매수이탈시간", "매수수량", "매수상위이탈원", "조회일자", "조회시간"],
				 "opt10054": ["종목코드", "종목명", "누적거래량", "발동가격", "동적괴리율", "매매체결처리시각", "VI해제시각", "VI적용구분", "동적기준가격", "정적기준가격", "정적괴리율",
				              "시가대비등락률", "VI발동횟수"], "opt10055": ["체결시간", "체결가", "전일대비기호", "전일대비", "등락율", "체결량", "누적거래량", "누적거래대금"],
				 "OPT10058": ["종목코드", "종목명", "순매도수량", "순매도금액", "추정평균가", "현재가", "대비기호", "전일대비", "평균가대비", "대비율", "기간거래량"],
				 "opt10059": ["일자", "현재가", "대비기호", "전일대비", "등락율", "누적거래량", "누적거래대금", "개인투자자", "외국인투자자", "기관계", "금융투자", "보험", "투신",
				              "기타금융", "은행", "연기금등", "사모펀드", "국가", "기타법인", "내외국인"],
				 "opt10060": ["일자", "현재가", "전일대비", "누적거래대금", "개인투자자", "외국인투자자", "기관계", "금융투자", "보험", "투신", "기타금융", "은행", "연기금등",
				              "사모펀드", "국가", "기타법인", "내외국인"],
				 "opt10061": ["개인투자자", "외국인투자자", "기관계", "금융투자", "보험", "투신", "기타금융", "은행", "연기금등", "사모펀드", "국가", "기타법인", "내외국인"],
				 "opt10062": ["종목코드", "순위", "종목명", "현재가", "대비기호", "전일대비", "등락율", "누적거래량", "기관순매매수량", "기관순매매금액", "기관순매매평균가",
				              "외인순매매수량", "외인순매매금액", "외인순매매평균가", "순매매수량", "순매매금액"],
				 "opt10063": ["종목명", "현재가", "대비기호", "전일대비", "등락율", "누적거래량", "순매수수량", "이점시전순매수수량", "순매수증감", "매수수량", "매수수량증감", "매도수량",
				              "매도수량증감"], "opt10064": ["시간", "외국인투자자", "기관계", "투신", "보험", "은행", "연기금등", "기타법인", "국가"],
				 "OPT10065": ["종목코드", "종목명", "매도량", "매수량", "순매도"],
				 "opt10066": ["종목코드", "종목명", "현재가", "대비기호", "전일대비", "등락률", "거래량", "개인투자자", "외국인투자자", "기관계", "금융투자", "보험", "투신",
				              "기타금융", "은행", "연기금등", "사모펀드", "국가", "기타법인"],
				 "OPT10067": ["종목명", "종목코드", "대차거래체결주수", "대차거래상환주수", "잔고주수", "잔고금액"],
				 "OPT10068": ["일자", "대차거래체결주수", "대차거래상환주수", "대차거래증감", "잔고주수", "잔고금액"],
				 "OPT10069": ["대차거래체결주수합", "대차거래상환주수합", "잔고주수합", "잔고금액합", "대차거래체결주수비율", "대차거래상환주수비율", "잔고주수비율", "잔고금액비율"],
				 "opt10070": ["매도거래원별증감1", "매도거래원수량1", "매도거래원1", "매도거래원코드1", "매수거래원1", "매수거래원코드1", "매수거래원수량1", "매수거래원별증감1",
				              "매도거래원별증감2", "매도거래원수량2", "매도거래원2", "매도거래원코드2", "매수거래원2", "매수거래원코드2", "매수거래원수량2", "매수거래원별증감2",
				              "매도거래원별증감3", "매도거래원수량3", "매도거래원3", "매도거래원코드3", "매수거래원3", "매수거래원코드3", "매수거래원수량3", "매수거래원별증감3",
				              "매도거래원별증감4", "매도거래원수량4", "매도거래원4", "매도거래원코드4", "매수거래원4", "매수거래원수량4", "매수거래원별증감4", "매도거래원별증감5",
				              "매도거래원수량5", "매도거래원5", "매도거래원코드5", "매수거래원5", "매수거래원코드5", "매수거래원수량5", "매수거래원별증감5", "외국계매도추정합변동",
				              "외국계매도추정합", "외국계매수추정합", "외국계매수추정합변동"],
				 "OPT10071": ["시간", "현재가", "대비기호", "전일대비", "대비율", "체결거래량", "누적거래량", "순간비율", "누적비율"],
				 "OPT10072": ["일자", "당일hts매도수수료", "종목명", "체결량", "매입단가", "체결가", "당일매도손익", "손익율", "종목코드", "당일매매수수료", "당일매매세금",
				              "인출가능금액", "대출일", "신용구분", "종목코드1", "당일매도손익1"],
				 "opt10073": ["일자", "당일hts매도수수료", "종목명", "체결량", "매입단가", "체결가", "당일매도손익", "손익율", "종목코드", "당일매매수수료", "당일매매세금",
				              "인출가능금액", "대출일", "신용구분"], "opt10074": ["총매수금액", "총매도금액", "실현손익", "매매수수료", "매매세금"],
				 "opt10075": ["계좌번호", "주문번호", "관리사번", "종목코드", "업무구분", "주문상태", "종목명", "주문수량", "주문가격", "미체결수량", "체결누계금액", "원주문번호",
				              "주문구분", "매매구분", "시간", "체결번호", "체결가", "체결량", "현재가", "매도호가", "매수호가", "단위체결가", "단위체결량", "당일매매수수료",
				              "당일매매세금", "개인투자자"],
				 "opt10076": ["주문번호", "종목명", "주문구분", "주문가격", "주문수량", "체결가", "체결량", "미체결수량", "당일매매수수료", "당일매매세금", "주문상태", "매매구분",
				              "원주문번호", "주문시간", "종목코드"], "opt10077": ["당일실현손익"],
				 "OPT10078": ["일자", "현재가", "대비기호", "전일대비", "등락율", "누적거래량", "순매수수량", "매수수량", "매도수량"], "opt10079": ["종목코드", "마지막틱갯수"],
				 "opt10080": ["종목코드"], "opt10081": ["종목코드"], "opt10082": ["종목코드"], "opt10083": ["종목코드"],
				 "opt10084": ["시간", "현재가", "전일대비", "대비율", "우선매도호가단위", "우선매수호가단위", "체결거래량", "sign", "누적거래량", "누적거래대금", "체결강도"],
				 "opt10085": ["일자", "종목코드", "종목명", "현재가", "매입가", "매입금액", "보유수량", "당일매도손익", "당일매매수수료", "당일매매세금", "신용구분", "대출일",
				              "결제잔고", "청산가능수량", "신용금액", "신용이자", "만기일"],
				 "opt10086": ["날짜", "시가", "고가", "저가", "종가", "전일비", "등락률", "거래량", "금액(백만)", "신용비", "개인", "기관", "외인수량", "외국계", "프로그램",
				              "외인비", "체결강도", "외인보유", "외인비중", "외인순매수", "기관순매수", "개인순매수", "신용잔고율"],
				 "opt10087": ["호가잔량기준시간", "시간외단일가_매도호가직전대비5", "시간외단일가_매도호가직전대비4", "시간외단일가_매도호가직전대비3", "시간외단일가_매도호가직전대비2",
				              "시간외단일가_매도호가직전대비1", "시간외단일가_매도호가수량5", "시간외단일가_매도호가수량4", "시간외단일가_매도호가수량3", "시간외단일가_매도호가수량2",
				              "시간외단일가_매도호가수량1", "시간외단일가_매도호가5", "시간외단일가_매도호가4", "시간외단일가_매도호가3", "시간외단일가_매도호가2", "시간외단일가_매도호가1",
				              "시간외단일가_매수호가1", "시간외단일가_매수호가2", "시간외단일가_매수호가3", "시간외단일가_매수호가4", "시간외단일가_매수호가5", "시간외단일가_매수호가수량1",
				              "시간외단일가_매수호가수량2", "시간외단일가_매수호가수량3", "시간외단일가_매수호가수량4", "시간외단일가_매수호가수량5", "시간외단일가_매수호가직전대비1",
				              "시간외단일가_매수호가직전대비2", "시간외단일가_매수호가직전대비3", "시간외단일가_매수호가직전대비4", "시간외단일가_매수호가직전대비5", "시간외단일가_매도호가총잔량",
				              "시간외단일가_매수호가총잔량", "매도호가총잔량직전대비", "매도호가총잔량", "매수호가총잔량", "매수호가총잔량직전대비", "시간외매도호가총잔량직전대비", "시간외매도호가총잔량",
				              "시간외매수호가총잔량", "시간외매수호가총잔량직전대비", "시간외단일가_현재가", "시간외단일가_전일대비기호", "시간외단일가_전일대비", "시간외단일가_등락률",
				              "시간외단일가_누적거래량"], "opt10094": ["종목코드"],
				 "opt20001": ["현재가", "전일대비기호", "전일대비", "등락률", "거래량", "거래대금", "거래형성종목수", "거래형성비율", "시가", "고가", "저가", "상한", "상승",
				              "보합", "하락", "하한", "52주최고가", "52주최고가일", "52주최고가대비율", "52주최저가", "52주최저가일", "52주최저가대비율"],
				 "OPT20002": ["종목코드", "종목명", "현재가", "전일대비기호", "전일대비", "등락률", "현재거래량", "매도호가", "매수호가", "시가", "고가", "저가"],
				 "opt20003": ["종목코드", "종목명", "현재가", "대비기호", "전일대비", "등락률", "거래량", "비중", "거래대금", "상한", "상승", "보합", "하락", "하한",
				              "상장종목수"], "opt20004": ["업종코드"], "opt20005": ["업종코드"], "opt20006": ["업종코드"], "opt20007": ["업종코드"],
				 "opt20008": ["업종코드"],
				 "opt20009": ["현재가", "전일대비기호", "전일대비", "등락률", "거래량", "거래대금", "거래형성종목수", "거래형성비율", "시가", "고가", "저가", "상한", "상승",
				              "보합", "하락", "하한", "52주최고가", "52주최고가일", "52주최고가대비율", "52주최저가", "52주최저가일", "52주최저가대비율"],
				 "opt20019": ["업종코드"], "opt20068": ["일자", "대차거래체결주수", "대차거래상환주수", "대차거래증감", "잔고주수", "잔고금액"], "OPT30001": ["기준가시간"],
				 "OPT30002": ["종목코드", "종목명", "주가등락", "등락율", "거래량", "순매수", "매수거래량", "매도거래량"],
				 "OPT30004": ["종목코드", "발행사명", "회차", "기초자산명", "권리구분", "괴리율", "베이시스", "잔존일수", "이론가", "현재가", "대비구분", "전일대비", "등락율",
				              "거래량", "종목명"],
				 "opt30005": ["종목코드", "발행사명", "회차", "기초자산명", "권리구분", "만기일", "현재가", "대비구분", "전일대비", "등락율", "거래량", "거래량대비", "거래대금",
				              "전일거래량", "매도호가", "매수호가", "패리티", "기어링비율", "손익분기율", "자본지지점", "이론가", "내재변동성", "델타", "레버리지", "행사가격",
				              "전환비율", "LP보유비율", "손익분기점", "최종거래일", "상장일", "LP초종공급일", "종목명", "잔존일수", "괴리율", "LP회원사명", "LP회원사명1",
				              "LP회원사명2", "Xray순간체결량정리매매구분", "Xray순간체결량증거금100구분"],
				 "OPT30008": ["체결시간", "내재변동성", "델타", "감마", "쎄타", "베가", "로", "X-Ray순간체결량증거금100%구분"],
				 "OPT30009": ["순위", "종목코드", "종목명", "현재가", "대비기호", "전일대비", "등락률", "매도잔량", "매수잔량", "거래량", "거래대금"],
				 "OPT30010": ["종목코드", "순위", "종목명", "현재가", "대비기호", "전일대비", "등락률", "거래량", "매도잔량", "매수잔량", "순매수잔량", "거래대금"],
				 "OPT30011": ["종목코드", "종목명", "현재가", "대비기호", "전일대비", "등락율", "누적거래량", "근접율"],
				 "opt30012": ["자산코드", "현재가", "전일대비기호", "전일대비", "등락율", "LP회원사명", "LP회원사명1", "LP회원사명2", "ELW권리내용", "ELW만기평가가격",
				              "ELW이론가", "괴리율", "ELW내재변동성", "예상권리가", "ELW손익분기율", "ELW행사가", "ELW전환비율", "ELW보상율", "ELW가격상승참여율",
				              "ELW권리유형", "ELW잔존일수", "주식수", "ELW LP주문가능", "LP보유비율", "LP보유수량", "ELW스프레드", "ELW패리티", "ELW기어링",
				              "ELW상장일", "ELW최종거래일", "만기일", "행사일", "LP공급종료일", "ELW지급일", "ELW투자지표산출", "ELW지급대리인", "ELW결재방법",
				              "ELW권리행사방식", "ELW발행기관", "확정지급액", "KO베리어", "IV", "종기종료ELW발생", "기초자산1", "기초자산구성비율1", "기초자산2",
				              "기초자산구성비율2", "기초자산3", "기초자산구성비율3", "기초자산4", "기초자산구성비율4", "기초자산5", "기초자산구성비율5", "평가시작일자", "평가종료일자",
				              "평가시작시간", "평가종료시간", "평가가격", "평가완료여부", "전체최고가", "전체최저가", "직후최고가", "직후최저가", "후반장최고가", "후반장최저가"],
				 "OPT40001": ["ETF수익률", "체결수익률", "외인순매수수량", "기관순매수수량"],
				 "opt40002": ["종목명", "ETF대상지수명", "원주가격", "ETF과세유형", "ETN과세유형"],
				 "OPT40003": ["체결일자", "현재가", "대비기호", "전일대비", "대비율", "거래량", "NAV", "누적거래대금", "NAV/지수괴리율", "NAV/ETF괴리율", "추적오차율",
				              "추적현재가", "추적전일대비", "추적대비기호"],
				 "opt40004": ["종목코드", "종목분류", "종목명", "종가", "대비기호", "전일대비", "대비율", "거래량", "NAV", "추적오차율", "과표기준", "배당전기준", "전일배당금",
				              "추적지수명", "배수", "추적지수코드", "추적지수", "추적등락율"],
				 "OPT40005": ["체결시간", "종가", "대비기호", "전일대비", "대비율", "거래량", "NAV", "누적거래대금", "NAV/지수괴리율", "NAV/ETF괴리율", "추적오차율",
				              "추적지수", "추적대비기호", "추적전일대비"], "opt40007": ["종목분류", "종목명", "ETF대상지수명", "ETF대상지수코드", "대상지수대비율", "원주가격"],
				 "opt40008": ["체결시간", "현재가", "대비기호", "전일대비", "거래량"],
				 "OPT40009": ["NAV", "NAV전일대비", "NAV등락율", "추적오차율", "괴리율", "주식수", "기준가", "외인보유수량", "대용가", "모름", "환산가격", "DR/주",
				              "원주가격"], "opt40010": ["현재가", "대비기호", "전일대비", "거래량", "외인순매수"], "opt50004": ["종목코드", "ATM구분", "행사가"],
				 "opt50007": ["현재가", "대비기호", "전일대비", "등락율", "시가", "고가", "저가", "누적거래량", "누적거래대금", "내재가치", "시간가치", "이론가", "괴리율"],
				 "opt50008": ["체결시간", "투자자별매도금액", "투자자별매수금액", "투자자별순매수금액"], "OPT50009": ["시가", "고가", "저가"],
				 "OPT50010": ["시가", "고가", "저가"],
				 "OPT50011": ["호가시간", "매도호가수량", "최우선매도호가", "매수호가수량", "최우선매수호가", "호가순잔량", "매도호가총잔량", "매수호가총잔량", "순매수잔량"],
				 "OPT50012": ["현재가", "체결시간"], "OPT50013": ["현재가", "거래량", "체결시간"],
				 "OPT50014": ["현재가", "대비기호", "전일대비", "등락율", "고가", "저가", "누적거래량", "미결제약정", "종목명", "누적거래대금"],
				 "opt50015": ["현재가s", "대비기호s", "전일대비s", "등락율s", "고가s", "저가s", "누적거래량s", "미결제약정s", "종목명s"], "OPT50016": ["전일종가"],
				 "OPT50017": ["현재가", "체결시간", "거래량", "시장베이시스", "시가", "고가", "저가", "괴리율"], "OPT50018": ["체결시간", "콜풋RATIO", "코스피200"],
				 "opt50020": ["현재가", "전일대비", "등락율", "대비기호", "시간가치", "내재가치", "내재변동성", "이론가", "괴리율", "미결제약정전일대비", "미결제약정", "누적거래대금",
				              "누적거래량", "매수호가총잔량", "매도호가총잔량", "매수호가수량", "매수호가", "매도호가수량", "매도호가", "기준가", "시가", "고가", "저가",
				              "기준가대비시가등락율", "기준가대비고가등락율", "기준가대비저가등락율", "지수환산", "예상체결가전일종가대비등락율", "예상체결가전일종가대비기호", "예상체결가전일종가대비",
				              "예상체결가", "종목코드", "ATM구분", "행사가", "대칭구분", "풋_현재가", "풋_전일대비", "풋_등락율", "풋_대비기호", "풋_시간가치", "풋_내재가치",
				              "풋_내재변동성", "풋_이론가", "풋_괴리율", "풋_미결제약정전일대비", "풋_미결제약정", "풋_누적거래대금", "풋_누적거래량", "풋_매수호가총잔량",
				              "풋_매도호가총잔량", "풋_매수호가수량", "풋_매수호가", "풋_매도호가수량", "풋_매도호가", "풋_기준가", "풋_시가", "풋_고가", "풋_저가",
				              "풋_기준가대비시가등락율", "풋_기준가대비고가등락율", "풋_기준가대비저가등락율", "풋_지수환산", "풋_예상체결가전일종가대비등락율", "풋_예상체결가전일종가대비기호",
				              "풋_예상체결가전일종가대비", "풋_예상체결가", "풋_종목코드", "풋_ATM구분", "풋_행사가"],
				 "OPT50021": ["지수환산", "ATM구분", "종목코드", "행사가", "현재가", "대비기호", "전일대비", "등락율", "시가", "기준가대비시가등락율", "고가", "기준가대비고가등락율",
				              "저가", "기준가대비저가등락율", "기준가", "매도호가", "매도호가수량", "매수호가", "매수호가수량", "매도호가총잔량", "매수호가총잔량", "누적거래량",
				              "누적거래대금", "미결제약정", "미결제약정전일대비", "괴리율", "이론가", "내재변동성", "내재가치", "시간가치", "델타", "감마", "세타", "베가", "로"],
				 "OPT50022": ["지수환산", "ATM구분", "종목코드", "행사가", "현재가", "대비기호", "전일대비", "등락율", "시가", "기준가대비시가등락율", "고가", "기준가대비고가등락율",
				              "저가", "기준가대비저가등락율", "기준가", "매도호가", "매도호가수량", "매수호가", "매수호가수량", "매도호가총잔량", "매수호가총잔량", "누적거래량",
				              "누적거래대금", "미결제약정", "미결제약정전일대비", "괴리율", "이론가", "내재변동성", "내재가치", "시간가치", "델타", "감마", "세타", "베가", "로"],
				 "opt50023": ["이론가", "괴리율", "내재변동성", "시장베이시스", "델타", "베가", "감마", "로", "종목코드", "종목명", "현재가", "대비기호", "전일대비", "등락율",
				              "누적거래량", "누적거래대금", "고가", "저가", "종목표준코드", "내재가치", "시간가치"],
				 "OPT50024": ["일자", "대표내재변동성", "콜내재변동성", "풋내재변동성", "선물대표내재변동성", "선물콜내재변동성", "선물풋내재변동성", "역사적변동성1", "역사적변동성2",
				              "역사적변동성3", "선물역사적변동성1", "선물역사적변동성2", "선물역사적변동성3", "시작일자"],
				 "OPT50026": ["주문번호", "종목코드", "종목명", "주문구분", "주문가격", "주문수량", "체결가", "체결량", "미체결수량", "주문상태", "원주문번호", "매매구분",
				              "주문체결시간"], "opt50028": ["종목코드", "마지막틱갯수"],
				 "OPT50029": ["현재가", "거래량", "체결시간", "시가", "고가", "저가", "수정주가이벤트", "전일종가"],
				 "OPT50030": ["현재가", "누적거래량", "일자", "시가", "고가", "저가", "수정주가이벤트", "전일종가"],
				 "OPT50035": ["현재가", "대비기호", "전일대비", "등락율", "시가", "고가", "저가", "누적거래", "거래량"],
				 "OPT50036": ["일자", "전일종가", "선물역사적변동성"], "opt50037": ["일자", "코스피200"],
				 "opt50038": ["평가손익", "매입단가", "투자자별순매수수량", "미결제약정", "대비기호", "전일대비", "현재가", "종목코드", "행사가", "지수환산", "ATM구분", "대칭구분",
				              "풋_종목코드", "풋_현재가", "풋_대비기호", "풋_전일대비", "풋_미결제약정", "풋_투자자별순매수수량", "풋_매입단가", "풋_평가손익"],
				 "OPT50043": ["종목코드", "종목표준코드", "종목명", "현재가", "대비기호", "전일대비", "등락율", "누적거래량"],
				 "opt50062": ["현재가s", "대비기호s", "전일대비s", "등락율s", "고가s", "저가s", "누적거래량s", "미결제약정s", "종목명s"],
				 "opt50063": ["현재가s", "대비기호s", "전일대비s", "등락율s", "고가s", "저가s", "누적거래량s", "미결제약정s", "종목명s"],
				 "opt50064": ["현재가s", "대비기호s", "전일대비s", "등락율s", "고가s", "저가s", "누적거래량s", "미결제약정s", "종목명s"],
				 "opt50065": ["종목코드", "ATM구분", "행사가"], "opt50066": ["종목코드", "마지막틱갯수"],
				 "opt50067": ["현재가", "거래량", "체결시간", "시가", "고가", "저가", "전일종가"],
				 "opt50068": ["현재가", "누적거래량", "일자", "시가", "고가", "저가", "전일종가"],
				 "OPT90001": ["종목코드", "테마명", "종목수", "등락기호", "등락율", "상승종목수", "하락종목수", "기간수익률", "주요종목"], "opt90002": ["등락률", "기간수익률"],
				 "opt90003": ["순위", "종목코드", "종목명", "현재가", "등락기호", "전일대비", "등락율", "누적거래량", "프로그램매도금액", "프로그램매수금액", "프로그램순매수금액"],
				 "OPT90004": ["합계1", "합계2", "합계3", "합계4", "합계5", "합계6"],
				 "OPT90005": ["체결시간", "차익거래매도", "차익거래매수", "차익거래순매수", "비차익거래매도", "비차익거래매수", "비차익거래순매수", "차익거래매도수량", "차익거래매수수량",
				              "차익거래순매수수량", "비차익거래매도수량", "비차익거래매수수량", "비차익거래순매수수량", "전체매도", "전체매수", "전체순매수", "KOSPI200", "BASIS"],
				 "OPT90006": ["일자", "매수차익거래수량", "매수차익거래금액", "매수차익거래증감액", "매도차익거래수량", "매도차익거래금액", "매도차익거래증감액"],
				 "OPT90007": ["일자", "KOSPI200", "BASIS", "차익거래당일", "차익거래누적", "비차익거래당일", "비차익거래누적", "전체당일", "전체누적"],
				 "opt90008": ["시간", "현재가", "대비기호", "전일대비", "등락율", "거래량", "프로그램매도금액", "프로그램매수금액", "프로그램순매수금액", "프로그램순매수금액증감",
				              "프로그램매도수량", "프로그램매수수량", "프로그램순매수수량", "프로그램순매수수량증감", "기준가시간", "대차거래상환주수합", "잔고수주합"],
				 "opt90009": ["외인순매도종목코드", "외인순매도종목명", "외인순매도금액", "외인순매도수량", "대칭구분", "외인순매수종목코드", "외인순매수종목명", "외인순매수금액", "외인순매수수량",
				              "대칭구분", "기관순매도종목코드", "기관순매도종목명", "기관순매도금액", "기관순매도수량", "대칭구분", "기관순매수종목코드", "기관순매수종목명", "기관순매수금액",
				              "기관순매수수량"], "OPT90010": ["기준일자"], "opt90011": ["기준일자"],
				 "OPT90012": ["종목명", "종목코드", "대차거래체결주수", "대차거래상환주수", "잔고주수", "잔고금액"],
				 "opt90013": ["일자", "현재가", "대비기호", "전일대비", "등락율", "거래량", "프로그램매도금액", "프로그램매수금액", "프로그램순매수금액", "프로그램순매수금액증감",
				              "프로그램매도수량", "프로그램매수수량", "프로그램순매수수량", "프로그램순매수수량증감", "기준가시간", "대차거래상환주수합", "잔고수주합"],
				 "opw00001": ["예수금", "주식증거금현금", "수익증권증거금현금", "익일수익증권매도정산대금", "해외주식원화대용설정금", "신용보증금현금", "신용담보금현금", "추가담보금현금",
				              "기타증거금", "미수확보금", "공매도대금", "신용설정평가금", "수표입금액", "기타수표입금액", "신용담보재사용", "코넥스기본예탁금", "ELW예탁평가금",
				              "신용대주권리예정금액", "생계형가입금액", "생계형입금가능금액", "대용금평가금액(합계)", "잔고대용평가금액", "위탁대용잔고평가금액", "수익증권대용평가금액",
				              "위탁증거금대용", "신용보증금대용", "신용담보금대용", "추가담보금대용", "권리대용금", "출금가능금액", "랩출금가능금액", "주문가능금액", "수익증권매수가능금액",
				              "20%종목주문가능금액", "30%종목주문가능금액", "40%종목주문가능금액", "100%종목주문가능금액", "현금미수금", "현금미수연체료", "현금미수금합계", "신용이자미납",
				              "신용이자미납연체료", "신용이자미납합계", "기타대여금", "기타대여금연체료", "기타대여금합계", "미상환융자금", "융자금합계", "대주금합계", "신용담보비율",
				              "중도이용료", "최소주문가능금액", "대출총평가금액", "예탁담보대출잔고", "매도담보대출잔고", "d+1추정예수금", "d+1매도매수정산금", "d+1매수정산금",
				              "d+1미수변제소요금", "d+1매도정산금", "d+1출금가능금액", "d+2추정예수금", "d+2매도매수정산금", "d+2매수정산금", "d+2미수변제소요금", "d+2매도정산금",
				              "d+2출금가능금액", "출력건수"], "OPW00002": ["출력건수"], "OPW00003": ["추정예탁자산"],
				 "OPW00004": ["계좌명", "지점명", "예수금", "D+2추정예수금", "유가잔고평가액", "예탁자산평가액", "총매입금액", "추정예탁자산", "매도담보대출금", "당일투자원금",
				              "당월투자원금", "누적투자원금", "당일투자손익", "당월투자손익", "누적투자손익", "당일손익율", "당월손익율", "누적손익율", "출력건수"],
				 "opw00005": ["예수금", "예수금D+1", "예수금D+2", "출금가능금액", "미수확보금", "대용금", "권리대용금", "주문가능현금", "현금미수금", "신용이자미납금", "기타대여금",
				              "미상환융자금", "증거금현금", "증거금대용", "주식매수총액", "평가금액합계", "총손익합계", "총손익률", "총재매수가능금액", "20주문가능금액", "30주문가능금액",
				              "40주문가능금액", "50주문가능금액", "60주문가능금액", "100주문가능금액", "신용융자합계", "신용융자대주합계", "신용담보비율", "예탁담보대출금액",
				              "매도담보대출금액", "조회건수"], "OPW00006": ["출력건수"], "OPW00007": ["출력건수"],
				 "opw00008": ["매매일자", "결제일자", "매도정산합", "매수정산합", "조회건수"], "opw00009": ["매도약정금액", "매수약정금액", "약정금액", "조회건수"],
				 "opw00010": ["증거금20주문가능금액", "증거금20주문가능수량", "증거금30주문가능금액", "증거금30주문가능수량", "증거금40주문가능금액", "증거금40주문가능수량",
				              "증거금50주문가능금액", "증거금50주문가능수량", "증거금60주문가능금액", "증거금60주문가능수량", "증거금감면60주문가능금", "증거금감면60주문가능수",
				              "증거금100주문가능금액", "증거금100주문가능수량", "전일재사용가능금액", "금일재사용가능금액", "예수금", "대용금", "미수금", "주문가능대용", "주문가능현금",
				              "인출가능금액", "익일인출가능금액", "매입금액", "수수료", "매입정산금", "D2추정예수금", "증거금감면적용구분"],
				 "opw00011": ["종목증거금율", "계좌증거금율", "적용증거금율", "증거금20주문가능금액", "증거금20주문가능수량", "증거금20전일재사용금액", "증거금20금일재사용금액",
				              "증거금30주문가능금액", "증거금30주문가능수량", "증거금30전일재사용금액", "증거금30금일재사용금액", "증거금40주문가능금액", "증거금40주문가능수량",
				              "증거금40전일재사용금액", "증거금40금일재사용금액", "증거금50주문가능금액", "증거금50주문가능수량", "증거금50전일재사용금액", "증거금50금일재사용금액",
				              "증거금60주문가능금액", "증거금60주문가능수량", "증거금60전일재사용금액", "증거금60금일재사용금액", "증거금100주문가능금액", "증거금100주문가능수량",
				              "증거금100전일재사용금액", "증거금100금일재사용금액", "미수불가주문가능금액", "미수불가주문가능수량", "미수불가전일재사용금액", "미수불가금일재사용금액", "예수금",
				              "대용금", "미수금", "주문가능대용", "주문가능현금"],
				 "OPW00012": ["종목보증금율", "종목보증금율명", "보증금30주문가능금액", "보증금30주문가능수량", "보증금30전일재사용금액", "보증금30금일재사용금액", "보증금40주문가능금액",
				              "보증금40주문가능수량", "보증금40전일재사용금액", "보증금40금일재사용금액", "보증금50주문가능금액", "보증금50주문가능수량", "보증금50전일재사용금액",
				              "보증금50금일재사용금액", "보증금60주문가능금액", "보증금60주문가능수량", "보증금60전일재사용금액", "보증금60금일재사용금액", "예수금", "대용금", "미수금",
				              "주문가능대용", "주문가능현금", "미수가능금액", "미수가능수량", "미수불가금액", "미수불가수량"],
				 "opw00013": ["금일재사용대상금액", "금일재사용사용금액", "금일재사용가능금액", "금일재사용제한금액", "금일재사용가능금액최종", "전일재사용대상금액", "전일재사용사용금액",
				              "전일재사용가능금액", "전일재사용제한금액", "전일재사용가능금액최종", "현금금액", "현금증거금", "사용가능현금", "현금사용제한금액", "사용가능현금최종", "대용금액",
				              "대용증거금", "사용가능대용", "대용사용제한금액", "사용가능대용최종", "신용보증금현금", "신용보증금대용", "신용담보금현금", "신용담보금대용", "미수금",
				              "대주담보금재사용금", "20주문가능금액", "30주문가능금액", "40주문가능금액", "50주문가능금액", "60주문가능금액", "100주문가능금액", "금일신용상환손실금액",
				              "전일신용상환손실금액", "금일대주상환손실대용증거금", "전일대주상환손실대용증거금", "평가대용금(현물사용제외)", "평가대용비율", "신용대용증거금", "현금주문대용증거금",
				              "신용주문대용증거금", "신용대용환산금", "대용가능금액", "대용가능금액2", "현금대용부족금", "신용대용부족금", "현금주문가능대용금", "신용주문가능대용금"],
				 "OPW00014": ["일치여부"], "OPW00015": ["계좌번호", "출력건수"],
				 "OPW00016": ["관리사원번호", "관리자명", "관리자지점", "예수금_초", "예수금_말", "유가증권평가금액_초", "유가증권평가금액_말", "대주담보금_초", "대주담보금_말",
				              "신용융자금_초", "신용융자금_말", "현금미수금_초", "현금미수금_말", "원화대용금_초", "원화대용금_말", "대주평가금_초", "대주평가금_말", "권리평가금_초",
				              "권리평가금_말", "대출금_초", "대출금_말", "기타대여금_초", "기타대여금_말", "신용이자미납금_초", "신용이자미납금_말", "신용이자_초", "신용이자_말",
				              "순자산액계_초", "순자산액계_말", "투자원금평잔", "평가손익", "수익률", "회전율", "기간내총입금", "기간내총출금", "기간내총입고", "기간내총출고",
				              "선물대용매도금액", "위탁대용매도금액"],
				 "OPW00017": ["D+2추정예수금", "신용이자미납금", "기타대여금", "일반주식평가금액D+2", "예탁담보대출금D+2", "예탁담보주식평가금액D+2", "신용융자금D+2",
				              "신용융자평가금D+2", "신용대주담보금D+2", "신용대주평가금D+2", "입금금액", "출금금액", "입고금액", "출고금액", "매도금액", "매수금액", "수수료", "세금",
				              "주식매입자금대출금", "RP평가금액", "채권평가금액", "ELS평가금액", "신용이자금액", "매도대금담보대출이자금액", "배당금액"],
				 "opw00018": ["총매입금액", "총평가금액", "총평가손익금액", "총수익률(%)", "추정예탁자산", "총대출금", "총융자금액", "총대주금액", "조회건수"],
				 "OPW20001": ["현재위탁증거금총액", "현재현금예탁필요액", "체결위탁증거금총액", "체결현금예탁필요액", "증감위탁증거금총액", "증감현금예탁필요액"],
				 "OPW20002": ["선물수수료", "옵션수수료", "주식옵션수수료", "선물매도수량", "선물매도금액", "선물매도평균가격", "선물매수수량", "선물매수금액", "선물매수평균가격", "선물전매수량",
				              "선물전매금액", "선물환매수량", "선물환매금액", "콜매도수량", "콜매도금액", "콜매도평균가격", "콜매수수량", "콜매수금액", "콜매수평균가격", "콜전매수량",
				              "콜전매금액", "콜환매수량", "콜환매금액", "풋매도수량", "풋매도금액", "풋매도평균가격", "풋매수수량", "풋매수금액", "풋매수평균가격", "풋전매수량", "풋전매금액",
				              "풋환매수량", "풋환매금액", "선물최종매도수량", "선물최종매도금액", "선물최종매도평균가격", "선물최종매수수량", "선물최종매수금액", "선물최종매수평균가격",
				              "콜권리행사수량", "콜권리행사금액", "콜권리행사가격", "풋권리행사수량", "풋권리행사금액", "풋권리행사가격", "콜권리배정수량", "콜권리배정금액", "콜권리배정가격",
				              "풋권리배정수량", "풋권리배정금액", "풋권리배정가격"],
				 "opw20003": ["선물약정금액", "옵션약정금액", "선물정산손익", "옵션매매손익", "총손익", "평균예탁금액", "예탁총액", "수수료", "수익율", "조회건수"],
				 "OPW20004": ["출력건수"], "OPW20005": ["출력건수"],
				 "opw20006": ["선물매도수량", "선물매수수량", "콜매도수량", "콜매수수량", "풋매도수량", "풋매수수량", "선물매도금액", "선물매수금액", "콜매도금액", "콜매수금액", "풋매도금액",
				              "풋매수금액", "약정합계", "손익합계", "조회건수"], "OPW20007": ["약정금액합계", "평가손익합계", "출력건수"],
				 "OPW20008": ["계좌명", "예탁총액", "추정예탁총액", "예탁현금", "추정예탁현금", "선물당일차금", "선물갱신차금", "선물최종결제차금", "선물예상정산손익", "옵션매수대금",
				              "옵션매도대금", "옵션행사차금", "옵션배정차금", "주식옵션행사대금", "주식옵션배정대금", "인수도대금", "전일대용매도체결금액", "금일대용매도체결금액", "선물수수료",
				              "옵션수수료", "결제가격수신여부", "유지증거금총액", "유지증거금총액부족액", "유지증거금현금부족액", "옵션잔고평가손익", "예탁대용", "익일결제예정금액"],
				 "opw20009": ["예탁총액", "예탁현금", "위탁증거금", "현금증거금", "주문가능금액", "주문가능총액", "신규가능수량", "청산가능수량", "총가능수량", "필요증거금총액", "총액부족액",
				              "주문가능현금", "필요증거금현금", "현금부족액", "주문가능대용금", "필요증거금대용금", "대용금부족액"],
				 "OPW20010": ["예탁총액", "예탁현금", "에탁대용", "증거금총액", "증거금현금", "증거금대용금", "주문가능총액", "주문가능현금", "주문가능대용금", "추가증거금총액",
				              "추가증거금현금", "추가증거금대용금", "인출가능총액", "인출가능현금", "인출가능대용금", "순자산금액", "익일예탁총액", "개장예탁총액", "선물정산차금", "선물청산손익",
				              "선물평가손익", "선물약정금액", "옵션결제차금", "옵션청산손익", "옵션평가손익", "옵션약정금액", "전일장종료예탁총액", "전일장종료예탁현금", "전일장종료예탁대용금"],
				 "OPW20011": ["출력건수"],
				 "opw20012": ["예탁총액", "예탁현금", "예탁대용", "위탁증거금총액", "위탁현금증거금", "유지증거금총액", "추가증거금총액", "추가증거금현금", "신규위탁증거금총액",
				              "선물신규주문증거금총액", "신규스프레드증거금", "옵션신규매수주문", "옵션신규매도주문", "위험위탁증거금", "옵션가격증거금", "가격변동증거금", "선물스프레드증거금",
				              "인수도증거금", "최소증거금", "당일옵션순매수대금", "옵션매수대금", "선물체결순손익", "선물정산차금", "옵션매도결제대금", "옵션매수결제대금", "수수료합계",
				              "선물최종결제차금", "인수도대금", "옵션행사대금", "옵션배정대금", "주문가능총액", "주문가능현금", "인출가능총액", "인출가능현금", "계좌명", "계좌번호",
				              "조회일자", "예탁평가총액", "익일예탁총액", "전일대용매도금", "금일대용매도금액", "미수연체료", "전일장종료예탁총액", "전일장종료예탁현금", "장중인출가능금액변경여부"],
				 "OPW20013": ["미결제수량", "청산가능수량", "현재증거금총액", "현재증거금현금", "예상위탁증거금", "예상현금증거금"],
				 "OPW20014": ["계좌명", "예탁총액", "예탁현금", "예탁대용금", "위탁증거금", "현금증거금", "추가증거금총액", "추가증거금현금", "추정예탁총액", "추정예탁현금",
				              "추정위탁증거금총액", "추정위탁증거금현금", "추정유지증거금총액", "추정유지증거금현금", "추정추가증거금총액", "추정추가증거금현금", "선물당일차금", "옵션결제대금",
				              "인수도대금", "수수료", "선물갱신차금", "선물최종차금", "옵션행사배정대금", "유지증거금기준부족액", "위탁증거금기준부족액", "사후증거금계좌구분", "결제가격수신여부",
				              "장종료예탁총액", "장종료예탁현금", "장종료예탁대용금", "조회건수"], "opw20015": ["종목코드", "ATM행사가격", "위치", "조회건수"],
				 "opw20016": ["신용융자가능여부", "출력건수"],}


		self.var_real_output = {"주식시세": "10, 11, 12, 27, 28, 13, 14, 16, 17, 18, 25, 26, 29, 30, 31, 32, 311, 567, 568",
	             "주식체결": "20, 10, 11, 12, 27, 28, 15, 13, 14, 16, 17, 18, 25, 26, 29, 30, 31, 32, 228, 311, 290, 691, 567",
		             "주식우선호가": "27, 28",
		             "주식호가잔량": "21, 41, 61, 81, 51, 71, 91, 42, 62, 82, 52, 72, 92, 43, 63, 83, 53, 73, 93, 44, 64, 84, 54, 74, 94, 45, 65, 85, 55, 75, 95, 46, 66, 86, 56, 76, 96, 47, 67, 87, 57, 77, 97, 48,  68, 88, 58, 78, 98, 49, 69, 89, 59, 79, 99, 50, 70, 90, 60, 80, 100, 121, 122, 125, 126, 23, 24, 128, 129, 138, 139, 200, 201, 238, 291, 292, 293, 294, 295, 621, 631, 622, 632,  623, 633, 624, 634, 625, 635, 626, 636, 627, 637, 628, 638, 629, 639, 630, 640, 13, 299, 215, 216",
		             "주식시간외호가": "21, 131, 132, 135, 136",
		             "주식당일거래원": "141, 161, 166, 146, 271, 151, 171, 176, 156, 281, 142, 162, 167, 147, 272, 152, 172,177, 157, 282, 143, 163, 168, 148, 273, 153, 173, 178, 158, 283, 144, 164, 169, 149, 274, 154, 174, 179, 159, 284, 145, 165, 170, 150, 275, 155, 175, 180, 160, 285, 261, 262, 263, 264, 267, 268, 337",
		             "ETF NAV": "36, 37, 38, 39, 20, 10, 11, 12, 13, 25, 667, 668, 669, 265, 266",
		             "ELW 지표": "20, 666, 1211, 667, 668, 669",
		             "ELW 이론가": "20, 10, 670, 671, 672, 673, 674, 675, 676, 706",
		             "주식예상체결": "20, 10, 11, 12, 15, 13, 25",
		             "주식종목정보": "297, 592, 593, 305, 306, 307, 689, 594, 382, 370, 300",
		             "선물시세": "20, 10, 11, 12, 27, 28, 15, 13, 14, 16, 17, 18, 195, 182, 184, 183, 186, 181, 185, 25, 197, 26, 246, 247, 248, 30, 196, 1365, 1366, 1367, 305, 306",
		             "선물호가잔량": "21, 27, 28, 41, 61, 81, 101, 51, 71, 91, 111, 42, 62, 82, 102, 52, 72, 92, 112, 43, 63, 83, 103, 53, 73, 93, 113, 44, 64, 84, 104, 54, 74, 94, 114, 45, 65, 85, 105, 55, 75, 95, 115, 121, 122, 123, 125, 126, 127, 137, 128, 13, 23, 238, 200, 201, 291, 293, 294, 295",
		             "선물이론가": "195, 182, 184, 183, 186, 181, 185, 246, 247, 248",
		             "옵션시세": "20, 10, 11, 12, 27, 28, 15, 13, 14, 16, 17, 18, 195, 182, 186, 190, 191, 193, 192, 194, 181, 25, 26, 137, 187, 197, 246, 247, 248, 219, 196, 188, 189, 30, 391, 392, 393, 1365, 1366, 1367, 305, 306,",
		             "옵션호가잔량": "21, 27, 28, 41, 61, 81, 101, 51, 71, 91, 111, 42, 62, 82, 102, 52, 72, 92, 112, 43, 63, 83, 103, 53, 73, 93, 113, 44, 64, 84, 104, 54, 74, 94, 114, 45, 65, 85, 105, 55, 75, 95, 115, 121, 122, 123, 125, 126, 127, 137, 128, 13, 23, 238, 200, 201, 291, 293, 294, 295",
		             "옵션이론가": "195, 182, 186, 190, 191, 193, 192, 194, 181, 246, 247, 248, 187, 188, 189",
		             "선물옵션우선호가": "10, 27, 28",
		             "업종지수": "20, 10, 11, 12, 15, 13, 14, 16, 17, 18, 25, 26",
		             "업종등락": "20, 252, 251, 253, 255, 254, 13, 14, 10, 11, 12, 256, 257, 25",
		             "장시작시간": "215, 20, 214",
		             "VI발동/해제": "9001, 302, 13, 14, 9068, 9008, 9075, 1221, 1223, 1224, 1225, 1236, 1237, 1238, 1239, 1489, 1490, 9069, 1279",
		             "주문체결": "9201, 9203, 9205, 9001, 912, 913, 302, 900, 901, 902, 903, 904, 905, 906, 907, 908, 909, 910, 911, 10, 27, 28, 914, 915, 938, 939, 919, 920, 921, 922, 923",
		             "파생잔고": "9201, 9001, 302, 10, 930, 931, 932, 933, 945, 946, 950, 951, 27, 28, 307, 8019, 397, 305, 306",
		             "잔고": "9201, 9001, 917, 916, 302, 10, 930, 931, 932, 933, 945, 946, 950, 951, 27, 28, 307, 8019,957, 958, 918, 990, 991, 992, 993, 959, 924",
		             "종목프로그램매매": "20, 10, 25, 11, 12, 13, 202, 204, 206, 208, 210, 212, 213, 214, 215, 216, "}

		#항목 : [항목1, 기본값1, 설명, {입력형태1:설명1, 입력형태2:설명1,.... }]
		#기본값중 알짜를 입력해야하는 부분은 아래와같이 바꿨다
		#{"basic_date":"기준일자","start_date":"시작일자","end_date":"종료일자","stock_no":"주식번호","today":"일자","today":"날짜","order_price":"주문가격",
		# "order_date":"체결일","check_start_date":"시작조회기간","check_end_date":"종료조회기간","check_date":"조회일자"}

		self.var_trcode_input_form = {
				'opt10001' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt10002' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt10003' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt10004' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt10005' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT10006' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt10007' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt10008' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT10009' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT10010' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt10011' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['신주인수권구분', '00', '', {'00': '전체', '05': '신주인수권증권', '07': '신주인수권증서'}]] ,
				'opt10012' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt10013' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['일자', 'today', '20160101', {}],
				              ['조회구분', '1', '', {'1': '융자', '2': '대주'}]] ,
				'opt10014' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간구분', '1', '', {'0': '시작일', '1': '기간'}],
				              ['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}]] ,
				'opt10015' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시작일자', 'start_date', '20160101', {}]] ,
				'OPT10016' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['신고저구분', '1', '', {'1': '신고가', '2': '신저가'}],
				              ['고저종구분', '1', '', {'1': '고저기준', '2': '종가기준'}],
				              ['종목조건', '0', '', {'0': '전체조회', '1': '관리종목제외', '3': '우선주제외', '5': '증100제외', '6': '증100만보기', '7': '증40만보기', '8': '증30만보기'}],
				              ['거래량구분', '0', '', {'0': '전체조회', '10': '만주이상', '50': '5  만주이상', '100': '10    만주이상', '150': '15    만주이상', '200': '20    만주이상', '300': '30만주이상', '500': '50만주이상', '1000': '100만주이상'}],
				              ['신용조건', '0', '', {'0': '전체조회', '1': '신용융자A군', '2': '신용융자B군', '3': '신용융자C군', '4': '신용융자D군', '9': '신용융자전체'}],
				              ['상하한포함', '1', '', {'0': '미포함', '1': '포함'}],
				              ['기간', '10', '', {'5': '5일', '10': '10일', '20': '20일', '60': '60일', '250': '250일'}]] ,
				'opt10017' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['상하한구분', '2', '', {'1': '상한', '2': '상승', '3': '보합', '4': '하한', '5': '하락', '6': '전일상한', '7': '전일하한'}],
				              ['정렬구분', '1', '', {'1': '종목코드순', '2': '연속횟수순(상위100개)', '3': '등락률순'}],
				              ['종목조건', '0', '', {'0': '전체조회', '1': '관리종목제외', '3': '우선주제외', '4': '우선주 + 관리종목제외', '5': '증100제외', '6': '증100만보기', '7': '증40만 보기', '8': '증30만보기', '9': '증20만보기', '10': '우선주 + 관리종목 + 환기종목제외'}],
				              ['거래량구분', '00000', '', {'00000': '전체조회', '00010': '만주이상', '00050': '5만주이상', '00100': '10만주이상', '00150': '15만주이상', '00200': '20만주이상', '00300': '30만주이상', '00500': '50만주이상', '01000': '100만주이상'}],
				              ['신용조건', '0', '', {'0': '전체조회', '1': '신용융자A군', '2': '신용융자B군', '3': '신용융자C군', '4': '신용융자D군', '9': '신용융자전체'}],
				              ['매매금구분', '0', '', {'0': '전체조회', '1': '1   천원미만', '2': '1   천원 ~2 천원', '3': '2 천원 ~3 천원', '4': '5 천원 ~1 만원', '5': '1 만원이상', '8': '1   천원이상'}]] ,
				'OPT10018' : [['고저구분', '1', '', {'1': '고가', '2': '저가'}],
				              ['근접율', '15', '', {'05': '0.5', '10': '1.0', '15': '1.5', '20': '2.0', '25': '2.5', '30': '3.0'}],
				              ['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['거래량구분', '00000', '', {'00000': '전체조회', '00010': '만주이상', '00050': '5만주이상', '00100': '10만주이상', '00150': '15만주이상', '00200': '20만주이상', '00300': '30만주이상', '00500': '50만주이상', '01000': '100만주이상'}],
				              ['종목조건', '0', '', {'0': '전체조회', '1': '관리종목제외', '3': '우선주제외', '5': '증100제외', '6': '증100만보기', '7': '증40만보기', '8': '증30만보기'}],
				              ['신용조건', '0', '', {'0': '전체조회', '1': '신용융자A군', '2': '신용융자B군', '3': '신용융자C군', '4': '신용융자D군', '9': '신용융자전체'}]] ,
				'opt10019' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['등락구분', '1', '', {'1': '급등', '2': '급락'}],
				              ['시간구분', '1', '', {'1': '분전', '2': '일전'}],
				              ['거래량구분', '00000', '', {'00000': '전체조회', '00010': '만주이상', '00050': '5만주이상', '00100': '10만주이상', '00150': '15만주이상', '00200': '20만주이상', '00300': '30만주이상', '00500': '50만주이상', '01000': '100만주이상'}],
				              ['종목조건', '0', '', {'0': '전체조회', '1': '관리종목제외', '3': '우선주제외', '5': '증100제외', '6': '증100만보기', '7': '증40만보기', '8': '증30만보기'}],
				              ['신용조건', '0', '', {'0': '전체조회', '1': '신용융자A군', '2': '신용융자B군', '3': '신용융자C군', '4': '신용융자D군', '9': '신용융자전체'}],
				              ['가격조건', '0', '', {'0': '전체조회', '1': '1천원미만', '2': '1천원~2천원', '3': '2천원~5천원', '4': '5천원~1만원', '5': '1만원이상', '8': '1천원이상'}],
				              ['상하한포함', '1', '', {'0': '미포함', '1': '포함'}]] ,
				'OPT10020' : [['시장구분', '101', '', {'001': '코스피', '101': '코스닥'}],
				              ['정렬구분', '1', '', {'1': '순매수잔량순', '2': '순매도잔량순', '3': '매수비율순', '4': '매도비율순'}],
				              ['거래량구분', '0000', '', {'0000': '장시작전(0주이상)', '0010': '만주이상', '0050': '5만주이상', '00100': '10만주이상'}],
				              ['종목조건', '0', '', {'0': '전체조회', '1': '관리종목제외', '5': '증100제외', '6': '증100만보기', '7': '증40만보기', '8': '증30만보기', '9': '증20만보기'}],
				              ['신용조건', '0', '', {'0': '전체조회', '1': '신용융자A군', '2': '신용융자B군', '3': '신용융자C군', '4': '신용융자D군', '9': '신용융자전체'}]] ,
				'OPT10021' : [['시장구분', '101', '', {'001': '코스피', '101': '코스닥'}],
				              ['매매구분', '1', '', {'1': '매수잔량', '2': '매도잔량'}],
				              ['정렬구분', '1', '', {'1': '급증량', '2': '급증률'}],
				              ['시간구분', '2', '', {'1': '분입력'}],
				              ['거래량구분', '5', '', {'1': '천주이상', '5': '5천주이상', '10': '만주이상', '50': '5만주이상', '100': '10만주이상'}],
				              ['종목조건', '0', '', {'0': '전체조회', '1': '관리종목제외', '5': '증100제외', '6': '증100만보기', '7': '증40만보기', '8': '증30만보기', '9': '증20만보기'}]] ,
				'OPT10022' : [['시장구분', '101', '', {'001': '코스피', '101': '코스닥'}],
				              ['비율구분', '1', '', {'1': '매수-매도비율', '2': '매도-매수비율'}],
				              ['시간구분', '5', '', {'1': '분입력'}],
				              ['거래량구분', '10', '', {'5': '5천주이상', '10': '만주이상', '50': '5만주이상', '100': '10만주이상'}],
				              ['종목조건', '0', '', {'0': '전체조회', '1': '관리종목제외', '5': '증100제외', '6': '증100만보기', '7': '증40만보기', '8': '증30만보기', '9': '증20만보기'}]] ,
				'OPT10023' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['정렬구분', '1', '', {'1': '급증량', '2': '급증률'}],
				              ['시간구분', '1', '', {'1': '분', '2': '전일'}],
				              ['거래량구분', '00000', '', {'00000': '전체조회', '00010': '만주이상', '00050': '5만주이상', '00100': '10만주이상', '00150': '15만주이상', '00200': '20만주이상', '00300': '30만주이상', '00500': '50만주이상', '01000': '100만주이상'}],
				              ['시간구분', '1', '', {'1': '분입력'}],
				              ['종목조건', '0', '', {'0': '전체조회', '1': '관리종목제외', '5': '증100제외', '6': '증100만보기', '7': '증40만보기', '8': '증30만보기', '9': '증20만보기'}],
				              ['가격구분', '0', '', {'0': '전체조회', '2': '5만원이상', '5': '1만원이상', '6': '5천원이상', '8': '1천원이상', '9': '10만원이상'}]] ,
				'OPT10024' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['주기구분', '10', '', {'5': '5일', '10': '10일', '20': '20일', '60': '60일', '250': '250일'}],
				              ['거래량구분', '00000', '', {'00000': '전체조회', '00010': '만주이상', '00050': '5만주이상', '00100': '10만주이상', '00150': '15만주이상', '00200': '20만주이상', '00300': '30만주이상', '00500': '50만주이상', '01000': '100만주이상'}]] ,
				'OPT10025' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['매물집중비율', '20', '', {'20': '0~100 입력'}],
				              ['현재가진입', '0', '', {'0': '현재가 매물대 집입 포함안함', '1': '현재가 매물대 집입포함'}],
				              ['매물대수', '5', '', {'5': '숫자입력'}],
				              ['주기구분', '100', '', {'50': '50일', '100': '100일', '150': '150일', '200': '200일', '250': '250일', '300': '300일'}]] ,
				'opt10026' : [['PER구분', '1', '', {'1': '코스피저PER', '2': '코스피고PER', '3': '코스닥저PER', '4': '코스닥고PER'}]] ,
				'opt10027' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['정렬구분', '1', '', {'1': '상승률', '2': '상승폭', '3': '하락률', '4': '하락폭'}],
				              ['거래량조건', '0000', '', {'0000': '전체조회', '0010': '만주이상', '0050': '5만주이상', '0100': '10만주이상', '0150': '15만주이상', '0200': '20만주이상', '0300': '30만주이상', '0500': '50만주이상', '1000': '백만주이상'}],
				              ['종목조건', '0', '', {'0': '전체조회', '1': '관리종목제외', '4': '우선주 + 관리주제외', '3': '우선주제외', '5': '증100제외', '6': '증100만보기', '7': '증40만보기', '8': '증30만보기', '9': '증20만보기', '11': '정리매매종목제외'}],
				              ['신용조건', '0', '', {'0': '전체조회', '1': '신용융자A군', '2': '신용융자B군', '3': '신용융자C군', '4': '신용융자D군', '9': '신용융자전체'}],
				              ['상하한포함', '1', '', {'0': '불 포함', '1': '포함'}],
				              ['가격조건', '0', '', {'0': '전체조회', '1': '1천원미만', '2': '1천원~2천원', '3': '2천원~5천원', '4': '5천원~1만원', '5': '1만원이상', '8': '1천원이상'}],
				              ['거래대금조건', '0', '', {'0': '전체조회', '3': '3천만원이상', '5': '5천만원이상', '10': '1억원이상', '30': '3억원이상', '50': '5억원이상', '100': '10억원이상', '300': '30억원이상', '500': '50억원이상', '1000': '100억원이상', '3000': '300억원이상', '5000': '500억원이상'}]] ,
				'opt10028' : [['정렬구분', '1', '', {'1': '시가', '2': '고가', '3': '저가', '4': '기준가'}],
				              ['거래량조건', '000', '', {'0000': '전체조회', '0010': '만주이상', '0050': '5만주이상', '0100': '10만주이상', '0500': '50만주이상', '1000': '백만주이상'}],
				              ['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['상하한포함', '1', '', {'0': '불 포함', '1': '포함'}],
				              ['종목조건', '0', '', {'0': '전체조회', '1': '관리종목제외', '4': '우선주 + 관리주제외', '3': '우선주제외', '5': '증100제외', '6': '증100만보기', '7': '증40만보기', '8': '증30만보기', '9': '증20만보기'}],
				              ['신용조건', '0', '', {'0': '전체조회', '1': '신용융자A군', '2': '신용융자B군', '3': '신용융자C군', '4': '신용융자D군', '9': '신용융자전체'}],
				              ['거래대금조건', '0', '', {'0': '전체조회', '3': '3천만원이상', '5': '5천만원이상', '10': '1억원이상', '30': '3억원이상', '50': '5억원이상', '100': '10억원이상', '300': '30억원이상', '500': '50억원이상', '1000': '100억원이상', '3000': '300억원이상', '5000': '500억원이상'}],
				              ['등락조건', '1', '', {'1': '상위', '2': '하위'}]] ,
				'opt10029' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['정렬구분', '1', '', {'1': '상승률', '2': '상승폭', '3': '보합', '4': '하락률', '5': '하락폭', '6': '체결량', '7': '상한', '8': '하한'}],
				              ['거래량조건', '000', '', {'0': '전체조회', '1': '천주이상', '3': '3천주', '5': '5천주', '10': '만주이상', '50': '5만주이상', '100': '10만주이상'}],
				              ['종목조건', '0', '', {'0': '전체조회', '1': '관리종목제외', '3': '우선주제외', '5': '증100제외', '6': '증100만보기', '7': '증40만보기', '8': '증30만보기', '9': '증20만보기', '11': '정리매매종목제외'}],
				              ['신용조건', '0', '', {'0': '전체조회', '1': '신용융자A군', '2': '신용융자B군', '3': '신용융자C군', '4': '신용융자D군', '9': '신용융자전체'}],
				              ['가격조건', '0', '', {'0': '전체조회', '1': '1천원미만', '2': '1천원~2천원', '3': '2천원~5천원', '4': '5천원~1만원', '5': '1만원이상', '8': '1천원이상'}]] ,
				'OPT10032' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['관리종목포함', '0', '', {'0': '관리종목 미포함', '1': '관리종목 포함'}]] ,
				'opt10033' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['거래량구분', '00000', '', {'00000': '전체조회', '00010': '만주이상', '00050': '5만주이상', '00100': '10만주이상', '00150': '15만주이상', '00200': '20만주이상', '00300': '30만주이상', '00500': '50만주이상', '01000': '100만주이상'}],
				              ['종목조건', '0', '', {'0': '전체조회', '1': '관리종목제외', '5': '증100제외', '6': '증100만보기', '7': '증40만보기', '8': '증30만보기', '9': '증20만보기'}],
				              ['상하한포함', '0', '', {'0': '상하한 미포함', '1': '상하한포함'}],
				              ['신용조건', '0', '', {'0': '전체조회', '1': '신용융자A군', '2': '신용융자B군', '3': '신용융자C군', '4': '신용융자D군', '9': '신용융자전체'}]] ,
				'OPT10034' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['매매구분', '1', '', {'1': '순매도', '2': '순매수', '3': '순매매'}],
				              ['기간', '0', '', {'0': '당일', '1': '전일', '5': '5일', '10': '10일', '20': '20일', '60': '60일'}]] ,
				'OPT10035' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['매매구분', '1', '', {'1': '연속순매도', '2': '연속순매수'}],
				              ['기준일구분', '0', '', {'0': '당일기준', '1': '전일기준'}]] ,
				'opt10036' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['기간', '0', '', {'0': '당일', '1': '전일', '5': '5일', '10': '10일', '20': '20일', '60': '60일'}]] ,
				'opt10037' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['기간', '0', '', {'0': '당일', '1': '전일', '5': '5일', '10': '10일', '20': '20일', '60': '60일'}],
				              ['매매구분', '1', '', {'1': '순매수', '2': '순매도', '3': '매수', '4': '매도'}],
				              ['정렬구분', '1', '', {'1': '금액', '2': '수량'}]] ,
				'opt10038' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}],
				              ['조회구분', '1', '', {'1': '순매도순위정렬', '2': '순매수순위정렬'}],
				              ['기간', '1', '', {'1': '전일', '4': '5일', '9': '10일', '19': '20일', '39': '40일', '59': '60일', '119': '120일'}]] ,
				'OPT10039' : [['회원사코드', '', 'please_input', {}],
				              ['거래량구분', '00000', '', {'00000': '전체조회', '00010': '만주이상', '00050': '5만주이상', '00100': '10만주이상', '00150': '15만주이상', '00200': '20만주이상', '00300': '30만주이상', '00500': '50만주이상', '01000': '100만주이상'}],
				              ['매매구분', '1', '', {'1': '순매수', '2': '순매도'}],
				              ['기간', '1', '', {'1': '전일', '5': '5일', '10': '10일', '60': '60일'}]] ,
				'opt10040' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt10042' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시작일자', 'start_date', '20210201', {}],
				              ['종료일자', 'end_date', '20210201', {}],
				              ['조회기간구분', '0', '', {'0': '기간으로 조회', '1': '시작일자', '종료일자로 조회': ''}],
				              ['시점구분', '0', '', {'0': '당일', '1': '전일'}],
				              ['기간', '5', '', {'5': '5일', '10': '10일', '20': '20일', '40': '40일', '60': '60일', '120': '120일'}],
				              ['정렬기준', '1', '', {'1': '종가순', '2': '날짜순'}]] ,
				'opt10043' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}],
				              ['조회기간구분', '0', '', {'0': '기간으로 조회', '1': '시작일자', '종료일자로 조회': ''}],
				              ['시점구분', '0', '', {'0': '당일', '1': '전일'}],
				              ['기간', '5', '', {'5': '5일', '10': '10일', '20': '20일', '40': '40일', '60': '60일', '120': '120일'}],
				              ['정렬기준', '1', '', {'1': '종가순', '2': '날짜순'}],
				              ['회원사코드', '', 'please_input', {'회원사 코드는 opt10042 조회 또는 GetBranchCodeName()함수사용': ''}]] ,
				'OPT10044' : [['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}],
				              ['매매구분', '1', '', {'0': '전체', '1': '순매도', '2': '순매수'}],
				              ['시장구분', '000', '', {'001': '코스피', '101': '코스닥'}]] ,
				'opt10045' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}],
				              ['기관추정단가구분', '', '1', {'1': '매수단가', '2': '매도단가'}],
				              ['외인추정단가구분', '', '1', {'1': '매수단가', '2': '매도단가'}]] ,
				'opt10046' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['틱구분', '1', '', {'설정값 1': ''}],
				              ['체결강도구분', '1', '', {'설정값 1': ''}]] ,
				'opt10047' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['틱구분', '1', '', {'설정값 1': ''}],
				              ['체결강도구분', '1', '', {'설정값 1': ''}]] ,
				'OPT10048' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT10050' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT10051' : [['시장구분', '000', '', {'0': '코스피', '1': '코스닥'}],
				              ['금액수량구분', '0', '', {'0': '금액', '1': '수량'}],
				              ['기준일자', 'basic_date', 'please_input', {}]] ,
				'opt10052' : [['회원사코드', '', 'please_input', {'manual': ' 회원사 코드는 opt10042 조회 또는 GetBranchCodeName()함수사용'}],
				              ['시장구분', '000', '', {'0': '전체', '1': '코스피', '2': '코스닥', '3': '종목'}],
				              ['수량구분', '0', '', {'0': '전체', '1': '1000주', '2': '2000주', '3': '', '5': '', '10': '10000주', '30': '30000주', '50': '50000주', '100': '100000주'}],
				              ['가격구분', '0', '', {'0': '전체', '1': '1천원 미만', '8': '1천원 이상', '2': '1천원 ~ 2천원', '3': '2천원 ~ 5천원', '4': '5천원 ~ 1만원', '5': '1만원 이상'}]] ,
				'opt10053' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt10054' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['장전구분', '0', '', {'0': '전체', '1': '정규시장', '2': '시간외단일가'}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['발동구분', '0', '', {'0': '전체', '1': '정적VI', '2': '동적VI', '3': '동적VI + 정적VI'}],
				              ['제외종목', '000000000', '', {'000000000': '전종목포함', '111111111': '전종목제외'}],
				              ['거래량구분', '0', '', {'0': '사용안함', '1': '사용'}],
				              ['최소거래량', '1', '', {'1': '거래량구분이 1일때만 입력(공백허용)'}],
				              ['최대거래량', '1', '', {'1': '거래량구분이 1일때만 입력(공백허용)'}],
				              ['거래대금구분', '0', '', {'0': '사용안함', '1': '사용'}],
				              ['최소거래대금', '0', '', {'0': '백만원 이상'}],
				              ['최대거래대금', '1', '', {'1': '거래량구분이 1일때만 입력(공백허용)'}],
				              ['발동방향', '0', '', {'0': '전체', '1': '상승', '2': '하락'}]] ,
				'opt10055' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['당일전일', '1', '', {'1': '당일', '2': '전일'}]] ,
				'OPT10058' : [['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}],
				              ['매매구분', '1', '', {'1': '순매도', '2': '순매수'}],
				              ['시장구분', '000', '', {'001': '코스피', '101': '코스닥'}],
				              ['투자자구분', '8000', '', {'8000': '개인', '9000': '외국인', '1000': '금융투자', '3000': '투신', '5000': '기타금융', '4000': '은행', '2000': '보험', '6000': '연기금', '7000': '국가', '7100': '기타법인', '9999': '기관계'}]] ,
				'opt10059' : [['일자', 'today', '20160101', {}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['금액수량구분', '1', '', {'1': '금액', '2': '수량'}],
				              ['매매구분', '1', '', {'0': '순매수', '1': '매수', '2': '매도'}],
				              ['단위구분', '1000', '', {'1000': '천주', '1': '단주'}]] ,
				'opt10060' : [['일자', 'today', '20160101', {}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['금액수량구분', '1', '', {'1': '금액', '2': '수량'}],
				              ['매매구분', '1', '', {'0': '순매수', '1': '매수', '2': '매도'}],
				              ['단위구분', '1000', '', {'1000': '천주', '1': '단주'}]] ,
				'opt10061' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}],
				              ['금액수량구분', '1', '', {'1': '금액', '2': '수량'}],
				              ['매매구분', '1', '', {'0': '순매수', '1': '매수', '2': '매도'}],
				              ['단위구분', '1000', '', {'1000': '천주', '1': '단주'}]] ,
				'opt10062' : [['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}],
				              ['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['매매구분', '1', '', {'1': '순매수', '2': '순매도'}],
				              ['정렬조건', '1', '', {'1': '수량', '2': '금액'}],
				              ['단위구분', '1', '', {'1': '단주', '1000': '천주'}]] ,
				'opt10063' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['금액수량구분', '1', '', {'1': '금액', '2': '수량'}],
				              ['투자자별', '6', '', {'6': '외국인', '7': '기관계', '1': '투신', '0': '보험', '2': '은행', '3': '연기금', '4': '국가', '5': '기타법인'}],
				              ['외국계전체', '1', '', {'1': '체크', '0': '언체크'}],
				              ['동시순매수구분', '1', '', {'1': '체크', '0': '언체크'}]] ,
				'opt10064' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['금액수량구분', '1', '', {'1': '금액', '2': '수량'}],
				              ['매매구분', '1', '', {'0': '순매수', '1': '매수', '2': '매도'}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT10065' : [['매매구분', '1', '', {'1': '순매수', '2': '순매도'}],
				              ['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['기관구분', '9000', '', {'9000': '외국인', '9100': '외국계', '1000': '금융투자', '3000': '투신', '5000': '기타금융', '4000': '은행', '2000': '보험', '6000': '연기금', '7000': '국가', '7100': '기타법인', '9999': '기관계'}]] ,
				'opt10066' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['금액수량구분', '1', '', {'1': '금액', '2': '수량'}],
				              ['매매구분', '1', '', {'0': '순매수', '1': '매수', '2': '매도'}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT10067' : [['기준일자', 'basic_date', '20160101', {}],
				              ['시장구분', '000', '', {'001': '코스피', '101': '코스닥'}]] ,
				'OPT10068' : [['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}],
				              ['전체구분', '1', '', {'1': '전체표시', '0': '종목코드 (지원안함.opt20068사용).'}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT10069' : [['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}],
				              ['시장구분', '000', '', {'001': '코스피', '101': '코스닥'}]] ,
				'opt10070' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT10071' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간구분', '1', '', {'1': '1분', '3': '3분', '5': '5분', '10': '10분', '15': '15분', '30': '30분', '60': '60분'}]] ,
				'OPT10072' : [['계좌번호', '', '보유계좌번호', {}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시작일자', 'start_date', '20160101', {}]] ,
				'opt10073' : [['계좌번호', '', '보유계좌번호', {}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}]] ,
				'opt10074' : [['계좌번호', '', '보유계좌번호', {}],
				              ['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}]] ,
				'opt10075' : [['계좌번호', '', '보유계좌번호', {}],
				              ['전체종목구분', '0', '', {'0': '전체', '1': '종목'}],
				              ['매매구분', '1', '', {'0': '전체', '1': '매도', '2': '매수'}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['체결구분', '0', '', {'0': '전체', '2': '체결', '1': '미체결'}]] ,
				'opt10076' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['조회구분', '0', '', {'0': '전체', '1': '종목'}],
				              ['매도수구분', '0', '', {'0': '전체', '1': '매도', '2': '매수'}],
				              ['계좌번호', '', '보유계좌번호', {}],
				              ['주문번호', '', 'please_input', {'조회할 주문번호': ''}],
				              ['체결구분', '0', '', {'0': '전체', '2': '체결', '1': '미체결'}]] ,
				'opt10077' : [['계좌번호', '', '보유계좌번호', {}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT10078' : [['회원사코드', '', 'please_input', {'manual': '회원사코드 입력'}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}]] ,
				'opt10079' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['틱범위', '1', '', {'1': '1틱', '3': '3틱', '5': '5틱', '10': '10틱', '30': '30틱'}],
				              ['수정주가구분', '1', '', {'1': '유상증자', '2': '무상증자', '4': '배당락', '8': '액면분할', '16': '액면병합', '32': '기업합병', '64': '감자', '256': '권리락'}]] ,
				'opt10080' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['틱범위', '1', '', {'1': '1분', '3': '3분', '5': '5분', '10': '10분', '15': '15분', '30': '30분', '45': '45분', '60': '60분'}],
				              ['수정주가구분', '1', '', {'1': '유상증자', '2': '무상증자', '4': '배당락', '8': '액면분할', '16': '액면병합', '32': '기업합병', '64': '감자', '256': '권리락'}]] ,
				'opt10081' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['기준일자', 'basic_date', '20160101', {}],
				              ['수정주가구분', '1', '', {'1': '유상증자', '2': '무상증자', '4': '배당락', '8': '액면분할', '16': '액면병합', '32': '기업합병', '64': '감자', '256': '권리락'}]] ,
				'opt10082' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['기준일자', 'basic_date', '20160101', {}],
				              ['수정주가구분', '1', '', {'1': '유상증자', '2': '무상증자', '4': '배당락', '8': '액면분할', '16': '액면병합', '32': '기업합병', '64': '감자', '256': '권리락'}]] ,
				'opt10083' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['기준일자', 'basic_date', '20160101', {}],
				              ['수정주가구분', '1', '', {'1': '유상증자', '2': '무상증자', '4': '배당락', '8': '액면분할', '16': '액면병합', '32': '기업합병', '64': '감자', '256': '권리락'}]] ,
				'opt10084' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['당일전일', '1', '', {1: '당일', '2': '전일'}],
				              ['틱분', '0', '', {'0': '틱', '1': '분'}],
				              ['시간', '1000', '조회시간 4자리, 오전 9시일 경우 0900, 오후 2시 30분일 경우 1430', {}]] ,
				'opt10085' : [['계좌번호', '', '보유계좌번호', {}]] ,
				'opt10086' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['조회일자', 'check_date', '20160101', {}],
				              ['표시구분', '0', '', {'0': '수량', '1': '금액(백만원)'}]] ,
				'opt10087' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt10094' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['기준일자', 'basic_date', '20160101', {}],
				              ['끝일자', '20210221', '20160101', {}],
				              ['수정주가구분', '1', '', {'1': '유상증자', '2': '무상증자', '4': '배당락', '8': '액면분할', '16': '액면병합', '32': '기업합병', '64': '감자', '256': '권리락'}]] ,
				'opt20001' : [['시장구분', '000', '', {'0': '코스피', '1': '코스닥', '2': '코스피200'}],
				              ['업종코드', '001', '', {'001': '종합(KOSPI)', '002': '대형주', '003': '중형주', '004': '소형주', '101': '종합(KOSDAQ)', '201': 'KOSPI200', '302': 'KOSTAR', '701': 'KRX100 나머지 ※ 업종코드 참고'}]] ,
				'OPT20002' : [['시장구분', '000', '', {'0': '코스피', '1': '코스닥', '2': '코스피200'}],
				              ['업종코드', '001', '', {'001': '종합(KOSPI)', '002': '대형주', '003': '중형주', '004': '소형주', '101': '종합(KOSDAQ)', '201': 'KOSPI200', '302': 'KOSTAR', '701': 'KRX100 나머지 ※ 업종코드 참고'}]] ,
				'opt20003' : [['업종코드', '001', '', {'001': '종합(KOSPI)', '002': '대형주', '003': '중형주', '004': '소형주', '101': '종합(KOSDAQ)', '201': 'KOSPI200', '302': 'KOSTAR', '701': 'KRX100 나머지 ※ 업종코드 참고'}]] ,
				'opt20004' : [['업종코드', '001', '', {'001': '종합(KOSPI)', '002': '대형주', '003': '중형주', '004': '소형주', '101': '종합(KOSDAQ)', '201': 'KOSPI200', '302': 'KOSTAR', '701': 'KRX100 나머지 ※ 업종코드 참고'}],
				              ['틱범위', '1', '', {'1': '1틱', '3': '3틱', '5': '5틱', '10': '10틱', '30': '30틱 '}]] ,
				'opt20005' : [['업종코드', '001', '', {'001': '종합(KOSPI)', '002': '대형주', '003': '중형주', '004': '소형주', '101': '종합(KOSDAQ)', '201': 'KOSPI200', '302': 'KOSTAR', '701': 'KRX100 나머지 ※ 업종코드 참고'}],
				              ['틱범위', '1', '', {'1': '1틱', '3': '3틱', '5': '5틱', '10': '10틱', '30': '30틱'}]] ,
				'opt20006' : [['업종코드', '001', '', {'001': '종합(KOSPI)', '002': '대형주', '003': '중형주', '004': '소형주', '101': '종합(KOSDAQ)', '201': 'KOSPI200', '302': 'KOSTAR', '701': 'KRX100 나머지 ※ 업종코드 참고'}],
				              ['기준일자', 'basic_date', '20160101', {}]] ,
				'opt20007' : [['업종코드', '001', '', {'001': '종합(KOSPI)', '002': '대형주', '003': '중형주', '004': '소형주', '101': '종합(KOSDAQ)', '201': 'KOSPI200', '302': 'KOSTAR', '701': 'KRX100 나머지 ※ 업종코드 참고'}],
				              ['기준일자', 'basic_date', '20160101', {}]] ,
				'opt20008' : [['업종코드', '001', '', {'001': '종합(KOSPI)', '002': '대형주', '003': '중형주', '004': '소형주', '101': '종합(KOSDAQ)', '201': 'KOSPI200', '302': 'KOSTAR', '701': 'KRX100 나머지 ※ 업종코드 참고'}],
				              ['기준일자', 'basic_date', '20160101', {}]] ,
				'opt20009' : [['시장구분', '1', '', {'0': '코스피', '1': '코스닥', '2': '코스피200'}],
				              ['업종코드', '001', '', {'001': '종합(KOSPI)', '002': '대형주', '003': '중형주', '004': '소형주', '101': '종합(KOSDAQ)', '201': 'KOSPI200', '302': 'KOSTAR', '701': 'KRX100 나머지 ※ 업종코드 참고'}]] ,
				'opt20019' : [['업종코드', '001', '', {'001': '종합(KOSPI)', '002': '대형주', '003': '중형주', '004': '소형주', '101': '종합(KOSDAQ)', '201': 'KOSPI200', '302': 'KOSTAR', '701': 'KRX100 나머지 ※ 업종코드 참고'}],
				              ['기준일자', 'basic_date', '20160101', {}]] ,
				'opt20068' : [['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}],
				              ['전체구분', '0', '', {'0': '종목코드 입력종목만 표시', '1': '전체표시(지원안함.OPT10068사용).'}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT30001' : [['등락구분', '1', '', {'1': '급등', '2': '급락'}],
				              ['시간구분', '1', '', {'1': '분전', '2': '일전'}],
				              ['시간', '5', '분 혹은 일입력 (예 1, 3, 5)', {}],
				              ['거래량구분', '00000', '', {'0': '전체', '10': '만주이상', '50': '5만주이상', '100': '10만주이상', '300': '30만주이상', '500': '50만주이상', '1000': '백만주이상'}],
				              ['발행사코드', '0', '', {'0': '전체', '3': '한국투자증권', '5': '미래대우', '6': '신영', '12': 'NK투자증권', '17': 'KB증권'}],
				              ['기초자산코드', '0', '', {'0': '전체', '201': 'KOSPI200', '150': 'KOSDAQ150', '5930': '삼정전자', '30200': 'KT'}],
				              ['권리구분', '000', '', {'000': '전체', '001': '콜', '002': '풋', '003': 'DC', '004': 'DP', '005': 'EX', '006': '조기종료콜', '007': '조기종료풋'}],
				              ['LP코드', '0', '', {'0': '전체', '3': '한국투자증권', '5': '미래대우', '6': '신영', '12': 'NK투자증권', '17': 'KB증권'}],
				              ['거래종료ELW제외', '0', '', {'0': '포함', '1': '제외'}]] ,
				'OPT30002' : [['발행사코드', '0', '', {'0': '전체', '3': '한국투자증권', '5': '미래대우', '6': '신영', '12': 'NK투자증권', '17': 'KB증권'}],
				              ['거래량구분', '00000', '', {'0': '전체', '5': '5천주', '10': '만주', '50': '5만주', '100': '10만주', '500': '50만주', '1000': '백만주'}],
				              ['매매구분', '1', '', {'1': '순매수', '2': '순매도'}],
				              ['기간', '1', '', {'1': '전일', '5': '5일', '10': '10일', '40': '40일', '60': '60일'}],
				              ['거래종료ELW제외', '0', '', {'0': '포함', '1': '제외'}]] ,
				'OPT30004' : [['발행사코드', '0', '', {'0': '전체', '3': '한국투자증권', '5': '미래대우', '6': '신영', '12': 'NK투자증권', '17': 'KB증권'}],
				              ['기초자산코드', '0', '', {'0': '전체', '201': 'KOSPI200', '150': 'KOSDAQ150', '5930': '삼정전자', '30200': 'KT'}],
				              ['권리구분', '000', '', {'000': '전체', '001': '콜', '002': '풋', '003': 'DC', '004': 'DP', '005': 'EX', '006': '조기종료콜', '007': '조기종료풋'}],
				              ['LP코드', '0', '', {'0': '전체', '3': '한국투자증권', '5': '미래대우', '6': '신영', '12': 'NK투자증권', '17': 'KB증권'}],
				              ['거래종료ELW제외', '1', '', {'1': '거래종료ELW제외', '0': '거래종료ELW포함'}]] ,
				'opt30005' : [['발행사코드', '0', '', {'0': '전체', '3': '한국투자증권', '5': '미래대우', '6': '신영', '12': 'NK투자증권', '17': 'KB증권'}],
				              ['기초자산코드', '0', '', {'0': '전체', '201': 'KOSPI200', '150': 'KOSDAQ150', '5930': '삼정전자', '30200': 'KT'}],
				              ['권리구분', '0', '', {'0': '전체', '1': '콜', '2': '풋', '3': 'DC', '4': 'DP', '5': 'EX', '6': '조기종료콜', '7': '조기종료풋'}],
				              ['LP코드', '0', '', {'0': '전체', '3': '한국투자증권', '5': '미래대우', '6': '신영', '12': 'NK투자증권', '17': 'KB증권'}],
				              ['정렬구분', '0', '', {'0': '정렬없음', '1': '상승율순', '2': '상승폭순', '3': '하락율순', '4': '하락폭순', '5': '거래량순', '6': '거래대금순', '7': '잔존일순'}]] ,
				'OPT30008' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT30009' : [['정렬구분', '1', '', {'1': '상승률', '2': '상승폭', '3': '하락률', '4': '하락폭'}],
				              ['권리구분', '000', '', {'000': '전체', '001': '콜', '002': '풋', '003': 'DC', '004': 'DP', '006': '조기종료콜', '007': '조기종료풋'}],
				              ['거래종료제외', '1', '', {'1': '거래종료제외', '0': '거래종료포함'}]] ,
				'OPT30010' : [['정렬구분', '1', '', {'1': '순매수잔량상위', '2': '순매도 잔량상위'}],
				              ['권리구분', '000', '', {'000': '전체', '001': '콜', '002': '풋', '003': 'DC', '004': 'DP', '006': '조기종료콜', '007': '조기종료풋'}],
				              ['거래종료제외', '1', '', {'1': '거래종료제외', '0': '거래종료포함'}]] ,
				'OPT30011' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt30012' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT40001' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['기간', '0', '', {'0': '1주', '1': '1달', '2': '6개월', '3': '1년'}]] ,
				'opt40002' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT40003' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt40004' : [['과세유형', '0', '', {'0': '전체', '1': '비과세', '2': '보유기간과세', '3': '회사형', '4': '외국', '5': '비과세해외(보유기간관세)'}],
				              ['NAV대비', '0', '', {'0': '전체', '1': 'NAV > 전일종가', '2': 'NAV < 전일종가'}],
				              ['운용사', '0000', '', {'0000': '전체', '3020': 'KODEX(삼성)', '3027': 'KOSEF(키움)', '3191': 'TIGER(미래에셋)', '3228': 'KINDEX(한국투자)', '3023': 'KStar(KB)', '3022': '아리랑(한화)', '9999': '기타운용사'}],
				              ['과세여부', '0', '', {'0': '전체', '1': '과세', '2': '비과세'}],
				              ['추적지수', '0', '', {'0': '전체'}]] ,
				'OPT40005' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt40007' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt40008' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT40009' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt40010' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opt50004' : [['만기년월', '', 'please_input', {'manual': 'YYYYMM - 6자리'}]] ,
				'opt50007' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간단위', '0', '', {'0': '일', '1': '1분', '5': '5분', '10': '10분', '15': '15분', '30': '30분'}]] ,
				'opt50008' : [['종목코드', '', '', {'P00101': '코스피', 'P10102': '코스닥'}]] ,
				'OPT50009' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT50010' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPT50011' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간단위', '00', '', {'00': '틱', '1': '1분', '5': '5분', '10': '10분', '15': '15분', '30': '30분', '0': '일'}]] ,
				'OPT50012' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간단위', '0', '', {'0': '30초', '1': '1분', '5': '5분', '10': '10분', '30': '30분', '99': '1일'}]] ,
				'OPT50013' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['봉갯수', '10', '', {'10': ''}]] ,
				'OPT50014' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['봉갯수', '10', '', {'10': ''}]] ,
				'opt50015' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간단위', '20210201', '', {'manual': 'YYYYMMDD(20160101)-연도4자리-월2자리- 일2자리 형식'}]] ,
				'OPT50016' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간단위', '1', '', {'00': '틱', '1': '1분', '5': '5분', '10': '10분', '15': '15분', '30': '30분', '0': '일'}]] ,
				'OPT50017' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간단위', '1', '', {'00': '틱', '1': '1분', '5': '5분', '10': '10분', '15': '15분', '30': '30분', '0': '일'}]] ,
				'OPT50018' : [['시간단위', '1', '', {'1': '1분', '5': '5분', '10': '10분', '15': '15분', '30': '30분', '60': '60분'}]] ,
				'opt50020' : [['만기년월', '202102', 'please_input', {'manual': 'YYYYMM - 6자리'}]] ,
				'OPT50021' : [['만기년월', '202102', 'please_input', {'manual': 'YYYYMM - 6자리'}]] ,
				'OPT50022' : [['만기년월', '202102', 'please_input', {'manual': 'YYYYMM - 6자리'}]] ,
				'opt50023' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간구분', '1', '', {'1': '1분', '3': '3분', '5': '5분', '10': '10분', '30': '30분'}]] ,
				'OPT50024' : [['역사적변동성1', '30', '', {'30': '변동성 일수'}],
				              ['역사적변동성2', '60', '', {'60': '변동성 일수'}],
				              ['역사적변동성3', '100', '', {'100': '변동성 일수'}],
				              ['기간', '60', '', {'60': '일수'}]] ,
				'OPT50026' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['조회구분', '0', '', {'0': '전체', '1': '종목별조합'}],
				              ['매매구분', '0', '', {'0': '전체', '1': '매도', '2': '매수'}],
				              ['체결구분', '0', '', {'0': '전체', '1': '미체결내역', '2': '체결내역'}]] ,
				'opt50028' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간단위', '1', '', {'1': '1틱', '3': '3틱', '5': '5틱', '10': '10틱', '20': '20틱', '30': '30틱', '60': '60틱', '120': '120틱'}]] ,
				'OPT50029' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간단위', '1', '', {'1': '1틱', '3': '3틱', '5': '5틱', '10': '10틱', '20': '20틱', '30': '30틱', '60': '60틱', '120': '120틱'}]] ,
				'OPT50030' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['기준일자', 'basic_date', 'please_input', {'manual': 'YYYYMM - 6자리'}]] ,
				'OPT50035' : [['종목코드', 'stock_no', 'please_input', {'_.DJI': '다우존스', '_COMP': '나스닥', '_SPX': 'S&P500', '_JP': '니케이', '001': '코스피'}],
				              ['기준일자', 'basic_date', 'please_input', {'manual': 'YYYYMM - 6자리'}],
				              ['차트구분', '0', '', {'0': '일차트', '1': '주차트', '2': '월차트'}]] ,
				'OPT50036' : [['종목코드', 'stock_no', 'please_input', {'_.DJI': '다우존스', '_COMP': '나스닥', '_SPX': 'S&P500', '_JP': '니케이', '001': '코스피'}],
				              ['기준일자', 'basic_date', 'please_input', {'manual': 'YYYYMM - 6자리'}],
				              ['차트구분', '0', '', {'0': '일차트', '1': '주차트', '2': '월차트'}]] ,
				'opt50037' : [['종목코드', 'stock_no', 'please_input', {'': '전문 조회할 종목코드(코스피200 지수 선물만 가능)'}],
				              ['기준일자', 'basic_date', 'please_input', {'manual': 'YYYYMMDD - 8자리'}]] ,
				'opt50038' : [['일자구분', '1', '', {'1': '일자', '2': '누적'}],
				              ['일자', 'today', 'please_input', {'manual': 'YYYYMMDD - 8자리'}],
				              ['투자자구분', '08', '', {'08': '개인', '09': '외국인', '01': '금융투자', '03': '투신', '04': '은행', '05': '기타금융', '02': '보험', '06': '연기금등', '07': '기타법인'}],
				              ['수량금액구분', '1', '', {'1': '수량', '2': '금액(백만원)'}]] ,
				'OPT50043' : [['거래대금구분', '0', '', {'0': '거래량상위', '1': '거래대금상위(천원)'}]] ,
				'opt50062' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간단위', '00', '', {'00': '30초', '1': '1분', '5': '5분', '10': '10분', '30': '30분', '60': '1시간'}]] ,
				'opt50063' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간단위', '', '20160101', {}]] ,
				'opt50064' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간단위', '00', '', {'00': '30초', '1': '1분', '5': '5분', '10': '10분', '30': '30분', '60': '1시간'}]] ,
				'opt50065' : [['기준일자', 'basic_date', 'please_input', {'manual': 'YYYYMM - 6자리'}]] ,
				'opt50066' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간단위', '1', '', {'1': '1틱', '3': '3틱', '5': '5틱', '10': '10틱', '20': '20틱', '30': '30틱', '60': '60틱', '120': '120틱'}]] ,
				'opt50067' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['시간단위', '1', '', {'1': '1틱', '3': '3틱', '5': '5틱', '10': '10틱', '20': '20틱', '30': '30틱', '60': '60틱', '120': '120틱'}]] ,
				'opt50068' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['기준일자', 'basic_date', 'please_input', {'manual': 'YYYYMM - 6자리'}]] ,
				'OPT90001' : [['검색구분', '0', '', {'0': '전체검색', '1': '테마검색', '2': '종목검색'}],
				              ['종목코드', 'stock_no', 'please_input', {'manual': '검색하려는 종목코드'}],
				              ['날짜구분', '', 'please_input', {'manual': '1일 ~ 99일 날짜입력'}],
				              ['테마명', '', '', {'': '검색하려는 테마명'}],
				              ['등락수익구분', '1', '', {'1': '상위기간수익률', '2': '하위기간수익률', '3': '상위등락률', '4': '하위등락률'}]] ,
				'opt90002' : [['날짜구분', '30', '', {'1일 ~ 99일 날짜입력': ''}],
				              ['종목코드', 'stock_no', 'please_input', {'manual': '테마그룹코드 번호'}]] ,
				'opt90003' : [['매매상위구분', '1', '', {'1': '순매도상위', '2': '순매수상위'}],
				              ['금액수량구분', '1', '', {'1': '금액', '2': '수량'}],
				              ['시장구분', '', '', {'P00101': '코스피', 'P10102': '코스닥'}]] ,
				'OPT90004' : [['일자', 'today', 'today', {}],
				              ['시장구분', '000', '', {'P00101': '코스피', 'P10102': '코스닥'}]] ,
				'OPT90005' : [['날짜', 'today', '20160101', {}],
				              ['시간구분', '1', '', {'1': '시간대별', '2': '일자별'}],
				              ['금액수량구분', '1', '', {'1': '금액(백만원)', '2': '수량(천주)'}],
				              ['시장구분', '000', '', {'P00101': '코스피', 'P10102': '코스닥'}],
				              ['분틱구분', '0', '', {'0': '틱', '1': '분'}]] ,
				'OPT90006' : [['날짜', 'today', '20160101', {}]] ,
				'OPT90007' : [['날짜', 'today', '20160101', {}],
				              ['금액수량구분', '1', '', {'1': '금액', '2': '수량'}],
				              ['시장구분', '000', '', {'P00101': '코스피', 'P10102': '코스닥'}]] ,
				'opt90008' : [['시간일자구분', '1', '', {'1': '시간대별'}],
				              ['금액수량구분', '1', '', {'1': '금액', '2': '수량'}],
				              ['날짜', 'today', '20160101', {}]] ,
				'opt90009' : [['시장구분', '000', '', {'000': '전체', '001': '코스피', '101': '코스닥'}],
				              ['금액수량구분', '1', '', {'1': '금액(천만)', '2': '수량(천)'}],
				              ['조회일자구분', '0', '', {'0': '조회일자 미포함', '1': '조회일자 포함'}],
				              ['날짜', 'today', '20160101', {}]] ,
				'OPT90010' : [['일자', 'today', '20160101', {}],
				              ['금액수량구분', '1', '', {'1': '금액', '2': '수량'}]] ,
				'opt90011' : [['일자', 'today', '20160101', {}],
				              ['금액수량구분', '1', '', {'1': '금액', '2': '수량'}]] ,
				'OPT90012' : [['일자', 'today', '20160101', {}],
				              ['시장구분', '000', '', {'001': '코스피', '101': '코스닥'}]] ,
				'opt90013' : [['시간일자구분', '2', '', {'2': '일자별'}],
				              ['금액수량구분', '1', '', {'1': '금액', '2': '수량'}],
				              ['날짜', 'today', '20160101', {}]] ,
				'opw00001' : [['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}],
				              ['조회구분', '2', '', {'3': '추정조회', '2': '일반조회'}]] ,
				'OPW00002' : [['계좌번호', '', '보유계좌번호', {}],
				              ['시작조회기간', 'check_start_date', '', {'manual': 'YYYYMMDD(20160101)-연도4자리-월2자리- 일2자리 형식'}],
				              ['종료조회기간', 'check_end_date', '', {'manual': 'YYYYMMDD(20160101)-연도4자리-월2자리- 일2자리 형식'}]] ,
				'OPW00003' : [['계좌번호', '', '보유계좌번호', {}],
				              ['상장폐지', '0', '', {'0': '전체', '1': '상장폐지종목제외'}]] ,
				'OPW00004' : [['계좌번호', '', '보유계좌번호', {}],
				              ['상장폐지', '0', '', {'0': '전체', '1': '상장폐지종목제외'}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'opw00005' : [['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'OPW00006' : [['일자', 'today', '20160101', {}],
				              ['0', '', '지점코드', {}],
				              ['시작주문번호', '00', '', {'00': ''}]] ,
				'OPW00007' : [['주문일자', 'today', '20160101', {}],
				              ['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}],
				              ['조회구분', '1', '', {'1': '주문순', '2': '역순', '3': '미체결', '4': '체결내역만'}],
				              ['주식채권구분', '0', '', {'0': '전체', '1': '주식', '2': '채권'}],
				              ['매도수구분', '0', '', {'0': '전체', '1': '매도', '2': '매수'}],
				              ['종목코드', 'stock_no', 'please_input', {'': '공백허용 (공백일때 전체종목)'}],
				              ['시작주문번호', '00', '', {'00': ''}]] ,
				'opw00008' : [['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'opw00009' : [['주문일자', 'today', '20160101', {}],
				              ['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}],
				              ['주식채권구분', '0', '', {'0': '전체', '1': '주식', '2': '채권'}],
				              ['시장구분', '000', '', {'0': '전체', '1': '장내', '2': '코스닥', '3': 'OTCBB', '4': 'ECN'}],
				              ['매도수구분', '0', '', {'0': '전체', '1': '매도', '2': '매수'}],
				              ['조회구분', '0', '', {'0': '전체', '1': '체결'}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'opw00010' : [['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}],
				              ['매매구분', '1', '', {'1': '매도', '2': '매수'}]] ,
				'opw00011' : [['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'OPW00012' : [['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'opw00013' : [['계좌번호', '', '보유계좌번호', {}]] ,
				'OPW00014' : [['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'OPW00015' : [['계좌번호', '', '보유계좌번호', {}],
				              ['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}],
				              ['구분', '0', '', {'0': '전체', '1': '입출금', '2': '입출고', '3': '매매', '4': '매수', '5': '매도', '6': '입금', '7': '출금', 'A': '예탁담보대출입금', 'F': '환전'}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['통화코드', '', '', {'': '전체', 'CNY': '', 'EUR': '', 'HKD': '', 'JPY': '', 'USD': ''}],
				              ['상품구분', '0', '', {'0': '전체', '1': '국내주식', '2': '수익증권', '3': '해외주식', '4': '금융상품'}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}],
				              ['고객정보제한여부', 'N', '', {'Y': '제한', 'N': '비제한'}]] ,
				'OPW00016' : [['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'OPW00017' : [['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '', '00', {'00': ''}]] ,
				'opw00018' : [['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}],
				              ['조회구분', '1', '', {'1': '합산', '2': '개별'}]] ,
				'OPW20001' : [['계좌번호', '', '보유계좌번호', {}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['매수매도구분', '1', '', {'1': '매도', '2': '매수'}]] ,
				'OPW20002' : [['계좌번호', '', '보유계좌번호', {}],
				              ['시장구분', '000', '', {'1': 'KOSPI지수'}],
				              ['체결일자', '', '20160101', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'opw20003' : [['계좌번호', '', '보유계좌번호', {}],
				              ['시장구분', '000', '', {'0': '전체'}],
				              ['시작일자', 'start_date', '20160101', {}],
				              ['종료일자', 'end_date', '20160101', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'OPW20004' : [['계좌번호', '', '보유계좌번호', {}],
				              ['조회일', 'today', '20160101', {}],
				              ['종목구분', '0', '', {'0': '전체', '1': '코스피선물', '2': '코스피옵션'}],
				              ['조회구분', '0', '', {'0': '전체', '1': '체결', '2': '미체결'}],
				              ['정렬구분', '1', '', {'1': '주문번호순', '2': '주문번호역순'}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}],
				              ['정규시간외구분', '0', '', {'0': '전체', '1': '정규장'}]] ,
				'OPW20005' : [['계좌번호', '', '보유계좌번호', {}],
				              ['조회일', 'today', '20160101', {}],
				              ['종목구분', '0', '', {'0': '전체', '1': '코스피선물', '2': '코스피옵션'}],
				              ['조회구분', '0', '', {'0': '전체', '1': '체결', '2': '미체결'}],
				              ['정렬구분', '1', '', {'1': '주문번호순', '2': '주문번호역순'}],
				              ['정규시간외구분', '0', '', {'0': '전체', '1': '정규장'}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'opw20006' : [['계좌번호', '', '보유계좌번호', {}],
				              ['조회일자', 'check_date', '20160101', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'OPW20007' : [['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'OPW20008' : [['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'opw20009' : [['계좌번호', '', '보유계좌번호', {}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}],
				              ['매도수구분', '1', '', {'1': '매도', '2': '매수'}],
				              ['주문유형', '1', '', {'1': '지정가'}],
				              ['주문가격', 'order_price', 'please_input', {'manual': '소수점제거한값(123.45 -> 12345)'}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'OPW20010' : [['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'OPW20011' : [['계좌번호', '', '보유계좌번호', {}],
				              ['증거금구분', '0', '', {'0': '위탁산출용', '1': '유지산출용'}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'opw20012' : [['계좌번호', '', '보유계좌번호', {}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'OPW20013' : [['계좌번호', '', '보유계좌번호', {}],
				              ['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] ,
				'OPW20014' : [['계좌번호', '', '보유계좌번호', {}],
				              ['KOSPI200지수', '', 'please_input', {'manual': '소수점제거한값(123.45 -> 12345)'}],
				              ['비밀번호입력매체구분', '00', '', {'00': ''}]] ,
				'opw20015' : [['월물구분', '', 'please_input', {'manual': '결제월(YYYYMM 연도4자리-월 2자리)'}],
				              ['클래스구분', '1', '', {'1': 'KOSPI200', '11': '삼성전자', '13': 'POSCO', '15': '한국전력', '16': '현대차', '19': '기아차', '24': 'LG전자', '40': '하나금융지주', '45': 'LGD', '46': 'KB금융', '50': 'SK하이닉스', '75': '미국달러'}]] ,
				'opw20016' : [['신용종목등급구분', 'A', '', {'A': 'A군', 'B': 'B군', 'C': 'C군'}],
				              ['시장거래구분', '%', '', {'%': '전체', '1': '코스피', '0': '코스닥'}],
				              ['종목번호', 'stock_no', '', {'': '공백가능'}]] ,
				'opw20017' : [['종목코드', 'stock_no', '종목코드를 입력하세요', {}]] }

		self.var_trcode_output_no_manual = {10: "현재가", 100: "매수호가직전대비10", 101: "매도호가건수1", 102: "매도호가건수2",
		                103: "매도호가건수3", 104: "매도호가건수4", 105: "매도호가건수5", 11: "전일대비",
		                111: "매수호가건수1", 112: "매수호가건수2", 113: "매수호가건수3", 114: "매수호가건수4",
		                115: "매수호가건수5", 12: "등락율", 121: "매도호가총잔량", 1211: "ELW프리미엄",
		                122: "매도호가총잔량직전대비", 1221: "VI발동가격", 1223: "매매체결처리시각", 1224: "VI해제시각",
		                1225: "VI적용구분", 123: "매도호가총건수", 1236: "기준가격정적", 1237: "기준가격동적",
		                1238: "괴리율정적", 1239: "괴리율동적", 125: "매수호가총잔량", 126: "매수호가총잔량직전대비",
		                127: "매수호가총건수", 1279: "ExtraItem", 128: "순매수잔량", 129: "매수비율",
		                13: "누적거래량", 131: "시간외매도호가총잔량", 132: "시간외매도호가총잔량직전대비", 135: "시간외매수호가총잔량",
		                136: "시간외매수호가총잔량직전대비", 1365: "실시간상한가", 1366: "실시간하한가", 1367: "협의대량누적체결수량",
		                137: "호가순잔량", 138: "순매도잔량", 139: "매도비율", 14: "누적거래대금", 141: "매도거래원1",
		                142: "매도거래원2", 143: "매도거래원3", 144: "매도거래원4", 145: "매도거래원5",
		                146: "매도거래원코드1", 147: "매도거래원코드2", 148: "매도거래원코드3", 1489: "ExtraItem",
		                149: "매도거래원코드4", 1490: "ExtraItem", 15: "거래량", 150: "매도거래원코드5",
		                151: "매수거래원1", 152: "매수거래원2", 153: "매수거래원3", 154: "매수거래원4",
		                155: "매수거래원5", 156: "매수거래원코드1", 157: "매수거래원코드2", 158: "매수거래원코드3",
		                159: "매수거래원코드4", 16: "시가", 160: "매수거래원코드5", 161: "매도거래원수량1",
		                162: "매도거래원수량2", 163: "매도거래원수량3", 164: "매도거래원수량4", 165: "매도거래원수량5",
		                166: "매도거래원별증감1", 167: "매도거래원별증감2", 168: "매도거래원별증감3", 169: "매도거래원별증감4",
		                17: "고가", 170: "매도거래원별증감5", 171: "매수거래원수량1", 172: "매수거래원수량2",
		                173: "매수거래원수량3", 174: "매수거래원수량4", 175: "매수거래원수량5", 176: "매수거래원별증감1",
		                177: "매수거래원별증감2", 178: "매수거래원별증감3", 179: "매수거래원별증감4", 18: "저가",
		                180: "매수거래원별증감5", 181: "미결제약정전일대비", 182: "이론가", 183: "시장베이시스",
		                184: "이론베이시스", 185: "괴리도", 186: "괴리율", 187: "내재가치", 188: "시간가치",
		                189: "내재변동성(I.V.)", 190: "델타", 191: "감마", 192: "베가", 193: "세타",
		                194: "로", 195: "미결제약정", 196: "미결제증감", 197: "KOSPI200", 20: "체결시간",
		                200: "예상체결가전일종가대비", 201: "예상체결가전일종가대비등락율", 202: "매도수량", 204: "매도금액",
		                206: "매수수량", 208: "매수금액", 21: "호가시간", 210: "순매수수량", 212: "순매수금액",
		                213: "순매수금액증감", 214: "장시작예상잔여시간", 215: "장운영구분", 216: "투자자별ticker",
		                219: "선물최근월물지수", 228: "체결강도", 23: "예상체결가", 238: "예상체결가전일종가대비기호",
		                24: "예상체결수량", 246: "시초미결제약정수량", 247: "최고미결제약정수량", 248: "최저미결제약정수량",
		                25: "전일대비기호", 251: "상한종목수", 252: "상승종목수", 253: "보합종목수", 254: "하한종목수",
		                255: "하락종목수", 256: "거래형성종목수", 257: "거래형성비율", 26: "전일거래량대비(계약,주)",
		                261: "외국계매도추정합", 262: "외국계매도추정합변동", 263: "외국계매수추정합", 264: "외국계매수추정합변동",
		                265: "NAV/지수괴리율", 266: "NAV/ETF괴리율", 267: "외국계순매수추정합", 268: "외국계순매수변동",
		                27: "(최우선)매도호가", 271: "매도거래원색깔1", 272: "매도거래원색깔2", 273: "매도거래원색깔3",
		                274: "매도거래원색깔4", 275: "매도거래원색깔5", 28: "(최우선)매수호가", 281: "매수거래원색깔1",
		                282: "매수거래원색깔2", 283: "매수거래원색깔3", 284: "매수거래원색깔4", 285: "매수거래원색깔5",
		                29: "거래대금증감", 290: "장구분", 291: "예상체결가", 292: "예상체결량",
		                293: "예상체결가전일대비기호", 294: "예상체결가전일대비", 295: "예상체결가전일대비등락율", 297: "임의연장",
		                299: "전일거래량대비예상체결률", 30: "전일거래량대비(비율)", 300: "ExtraItem", 302: "종목명",
		                305: "상한가", 306: "하한가", 307: "기준가", 31: "거래회전율", 311: "시가총액(억)",
		                32: "거래비용", 337: "거래소구분", 36: "NAV", 37: "NAV전일대비", 370: "종목정보",
		                38: "NAV등락율", 382: "증거금율표시", 39: "추적오차율", 391: "기준가대비시가등락율",
		                392: "기준가대비고가등락율", 393: "기준가대비저가등락율", 397: "파생상품거래단위", 41: "매도호가1",
		                42: "매도호가2", 43: "매도호가3", 44: "매도호가4", 45: "매도호가5", 46: "매도호가6",
		                47: "매도호가7", 48: "매도호가8", 49: "매도호가9", 50: "매도호가10", 51: "매수호가1",
		                52: "매수호가2", 53: "매수호가3", 54: "매수호가4", 55: "매수호가5", 56: "매수호가6",
		                567: "상한가발생시간", 568: "하한가발생시간", 57: "매수호가7", 58: "매수호가8",
		                59: "매수호가9", 592: "장전임의연장", 593: "장후임의연장", 594: "통화단위", 60: "매수호가10",
		                61: "매도호가수량1", 62: "매도호가수량2", 621: "LP매도호가수량1", 622: "LP매도호가수량2",
		                623: "LP매도호가수량3", 624: "LP매도호가수량4", 625: "LP매도호가수량5", 626: "LP매도호가수량6",
		                627: "LP매도호가수량7", 628: "LP매도호가수량8", 629: "LP매도호가수량9", 63: "매도호가수량3",
		                630: "LP매도호가수량10", 631: "LP매수호가수량1", 632: "LP매수호가수량2", 633: "LP매수호가수량3",
		                634: "LP매수호가수량4", 635: "LP매수호가수량5", 636: "LP매수호가수량6", 637: "LP매수호가수량7",
		                638: "LP매수호가수량8", 639: "LP매수호가수량9", 64: "매도호가수량4", 640: "LP매수호가수량10",
		                65: "매도호가수량5", 66: "매도호가수량6", 666: "ELW패리티", 667: "ELW기어링비율",
		                668: "ELW손익분기율", 669: "ELW자본지지점", 67: "매도호가수량7", 670: "ELW이론가",
		                671: "ELW내재변동성", 672: "ELW델타", 673: "ELW감마", 674: "ELW쎄타",
		                675: "ELW베가", 676: "ELW로", 68: "매도호가수량8", 689: "조기종료ELW발생",
		                69: "매도호가수량9", 691: "KO접근도", 70: "매도호가수량10", 706: "LP호가내재변동성",
		                71: "매수호가수량1", 72: "매수호가수량2", 73: "매수호가수량3", 74: "매수호가수량4",
		                75: "매수호가수량5", 76: "매수호가수량6", 77: "매수호가수량7", 78: "매수호가수량8",
		                79: "매수호가수량9", 80: "매수호가수량10", 8019: "손익율", 81: "매도호가직전대비1",
		                82: "매도호가직전대비2", 83: "매도호가직전대비3", 84: "매도호가직전대비4", 85: "매도호가직전대비5",
		                86: "매도호가직전대비6", 87: "매도호가직전대비7", 88: "매도호가직전대비8", 89: "매도호가직전대비9",
		                90: "매도호가직전대비10", 900: "주문수량", 9001: "종목코드,업종코드",
		                9008: "KOSPI,KOSDAQ,전체구분", 901: "주문가격", 902: "미체결수량", 903: "체결누계금액",
		                904: "원주문번호", 905: "주문구분", 906: "매매구분", 9068: "VI발동구분(1:정적,2:동적,3:동적+정적)",
		                9069: "ExtraItem", 907: "매도수구분", 9075: "장전구분", 908: "주문/체결시간",
		                909: "체결번호", 91: "매수호가직전대비1", 910: "체결가", 911: "체결량", 912: "주문업무분류",
		                913: "주문상태", 914: "단위체결가", 915: "단위체결량", 916: "대출일", 917: "신용구분",
		                918: "만기일", 919: "거부사유", 92: "매수호가직전대비2", 920: "화면번호", 9201: "계좌번호",
		                9203: "주문번호", 9205: "관리자사번", 921: "터미널번호", 922: "신용구분(실시간체결용)",
		                923: "대출일(실시간체결용)", 924: "ExtraItem", 93: "매수호가직전대비3", 930: "보유수량",
		                931: "매입단가", 932: "총매입가", 933: "주문가능수량", 938: "당일매매수수료",
		                939: "당일매매세금", 94: "매수호가직전대비4", 945: "당일순매수량", 946: "매도/매수구분",
		                95: "매수호가직전대비5", 950: "당일총매도손일", 951: "예수금", 957: "신용금액",
		                958: "신용이자", 959: "담보대출수량", 96: "매수호가직전대비6", 97: "매수호가직전대비7",
		                98: "매수호가직전대비8", 99: "매수호가직전대비9", 990: "당일실현손익(유가)", 991: "당일실현손익률(유가)",
		                992: "당일실현손익(신용)", 993: "당일실현손익률(신용)"}